<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  admin_upgrade.php                                        ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	/* Function, that compares two versions in string format
	   returns 1 (if first is bigger), 2 (if second), or 0 if equal */
	function comp_vers($version1, $version2)
	{
		$first_numbers = explode(".", $version1);
		$second_numbers = explode(".", $version2);

		if (count($first_numbers) > count($second_numbers)) {
			for ($i = 0; isset($first_numbers[$i]); $i++)  if (!isset($second_numbers[$i])) $second_numbers[$i] = "0";
		} else
			for ($i = 0; isset($second_numbers[$i]); $i++) if (!isset($first_numbers[$i])) $first_numbers[$i] = "0";
			
		foreach ($first_numbers as $key => $value) {
				if ($first_numbers[$key] > $second_numbers[$key]) return 1;			  
				elseif ($first_numbers[$key] < $second_numbers[$key]) return 2;			  
			}
	
		return 0;
	}

	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/date_functions.php");
	include_once ($root_folder_path . "messages/".$language_code."/install_messages.php");

	check_admin_security("site_settings");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main", "admin_upgrade.html");
	$t->set_var("admin_upgrade_href", "admin_upgrade.php");
	$upgrade_button = str_replace("{version_number}", VA_RELEASE, UPGRADE_BUTTON);

	include("./admin_header.php");
	include("./admin_footer.php");

	// $last_version is version from http://www.viart.com/viart_shop.xml
	$viart_xml = @fsockopen("www.viart.com", 80, $errno, $errstr, 12);

	if ($viart_xml) {

		fputs($viart_xml, "GET /viart_shop.xml HTTP/1.0\r\n");
		fputs($viart_xml, "Host: www.viart.com\r\n");
		fputs($viart_xml, "Referer: http://www.viart.com\r\n");
		fputs($viart_xml, "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)\r\n\r\n");
		
		$last_version = "";
		
		while (!feof($viart_xml)) {
			$line = fgets($viart_xml);
			if (strpos($line, "Program_Version")) {
				for ($i = 0; $i < strlen($line); $i++) if ((is_numeric($line[$i])) or ($line[$i] == ".")) $last_version .= $line[$i];
			}
		}
		
		$xml_opened = true;
		fclose($viart_xml);
		
	} else {
		$last_version = VA_RELEASE;
		$xml_opened = false;
	}
	// end $last_version find out

	$t->set_var("UPGRADE_TITLE",         UPGRADE_TITLE);
	$t->set_var("UPGRADE_NOTE",          UPGRADE_NOTE);
	$t->set_var("UPGRADE_AVAILABLE_MSG", UPGRADE_AVAILABLE_MSG);
	$t->set_var("UPGRADE_BUTTON",        $upgrade_button);
	$t->set_var("CURRENT_VERSION_MSG",   CURRENT_VERSION_MSG);
	$t->set_var("LATEST_VERSION_MSG",    LATEST_VERSION_MSG);
	$t->set_var("UPGRADE_RESULTS_MSG",   UPGRADE_RESULTS_MSG);
	$t->set_var("SQL_SUCCESS_MSG",       SQL_SUCCESS_MSG);
	$t->set_var("SQL_FAILED_MSG",        SQL_FAILED_MSG);
	$t->set_var("SQL_TOTAL_MSG",         SQL_TOTAL_MSG);
	$t->set_var("VERSION_UPGRADED_MSG",  VERSION_UPGRADED_MSG);
	$t->set_var("ALREADY_LATEST_MSG",    ALREADY_LATEST_MSG);
	$t->set_var("DOWNLOAD_NEW_MSG",      DOWNLOAD_NEW_MSG);
	
	$download_found = str_replace("{version_number}", $last_version, DOWNLOAD_FOUND_MSG);
	$download_now = str_replace("{version_number}", $last_version, DOWNLOAD_NOW_MSG);
	
	$t->set_var("DOWNLOAD_FOUND_MSG",    $download_found);
	$t->set_var("DOWNLOAD_NOW_MSG",      $download_now);

	$version = array();

	$sql  = " SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings ";
	$sql .= " WHERE setting_type='version' ";
	$db->query($sql);
	
	while ($db->next_record()) {
		$setting_name = $db->f("setting_name");
		$setting_value = $db->f("setting_value");
		$version[$setting_name] = $setting_value;
	}

	if(isset($version["number"])) {
		$current_db_version = $version["number"];
	} else if (defined("VA_RELEASE")) {
		$current_db_version = VA_RELEASE;
	} else {
		$current_db_version = "2.1";
	}
	
	$operation = get_param("operation");
	
	if ($operation == "upgrade") {
		$ct = get_param("ct");
		$session_ct = get_session("session_ct");
		if ($ct != $session_ct) {
			set_session("session_ct", $ct);
			$sqls = array();
			if (comp_vers("2.1.5", $current_db_version) == "first") {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN start_html TEXT",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN start_html TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN start_html LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN middle_html TEXT",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN middle_html TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN middle_html LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN end_html TEXT",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN end_html TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN end_html LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];
			}
			if (comp_vers("2.1.6", $current_db_version) == 1) {
				$mysql_sql   = "CREATE TABLE " . $table_prefix . "items_related (";
				$mysql_sql  .= "`item_id` INT(11) NOT NULL default '0', ";
				$mysql_sql  .= "`related_id` INT(11) NOT NULL default '0', ";
				$mysql_sql  .= "`related_order` INT(11) NOT NULL default '1', ";
				$mysql_sql  .= "KEY item_id (item_id),";
				$mysql_sql  .= "KEY related_id (related_id))";
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "items_related (";
				$postgre_sql .= "item_id INT4 NOT NULL default '0', ";
				$postgre_sql .= "related_id INT4 NOT NULL default '0', ";
				$postgre_sql .= "related_order INT4 NOT NULL default '1') ";
				$access_sql  = "CREATE TABLE " . $table_prefix . "items_related (";
				$access_sql .= "[item_id] INTEGER, [related_id] INTEGER, [related_order] INTEGER) ";
				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];


				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN signature TEXT",
					"postgre" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN signature TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN signature LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];
				if (VA_TYPE == "enterprise") {

					$mysql_sql   = "CREATE TABLE " . $table_prefix . "support_attachments (";
					$mysql_sql  .= "  `attachment_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `support_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `file_name` VARCHAR(255),";
					$mysql_sql  .= "  `date_added` DATETIME";
					$mysql_sql  .= "  ,PRIMARY KEY (attachment_id)";
					$mysql_sql  .= "  ,KEY support_id (support_id))";
					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "support_attachments START 1";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "support_attachments (";
					$postgre_sql .= "  attachment_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "support_attachments'),";
					$postgre_sql .= "  support_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  file_name VARCHAR(255),";
					$postgre_sql .= "  date_added TIMESTAMP";
					$postgre_sql .= "  ,PRIMARY KEY (attachment_id))";
					$access_sql  = "CREATE TABLE " . $table_prefix . "support_attachments (";
					$access_sql .= "  [attachment_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [support_id] INTEGER,";
					$access_sql .= "  [file_name] VARCHAR(255),";
					$access_sql .= "  [date_added] DATETIME";
					$access_sql .= "  ,PRIMARY KEY (attachment_id))";
					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];


					$mysql_sql   = "CREATE TABLE " . $table_prefix . "support_departments (";
					$mysql_sql  .= "  `dep_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `short_title` VARCHAR(255),";
					$mysql_sql  .= "  `full_title` VARCHAR(255),";
					$mysql_sql  .= "  `signature` TEXT,";
					$mysql_sql  .= "  `incoming_account` TEXT,";
					$mysql_sql  .= "  `outgoing_account` VARCHAR(50),";
					$mysql_sql  .= "  `show_for_user` INT(11) NOT NULL default '1'";
					$mysql_sql  .= "  ,PRIMARY KEY (dep_id))";
					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "support_departments START 1";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "support_departments (";
					$postgre_sql .= "  dep_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "support_departments'),";
					$postgre_sql .= "  short_title VARCHAR(255),";
					$postgre_sql .= "  full_title VARCHAR(255),";
					$postgre_sql .= "  signature TEXT,";
					$postgre_sql .= "  incoming_account TEXT,";
					$postgre_sql .= "  outgoing_account VARCHAR(50),";
					$postgre_sql .= "  show_for_user INT4 NOT NULL default '1'";
					$postgre_sql .= "  ,PRIMARY KEY (dep_id))";
					$access_sql  = "CREATE TABLE " . $table_prefix . "support_departments (";
					$access_sql .= "  [dep_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [short_title] VARCHAR(255),";
					$access_sql .= "  [full_title] VARCHAR(255),";
					$access_sql .= "  [signature] LONGTEXT,";
					$access_sql .= "  [incoming_account] LONGTEXT,";
					$access_sql .= "  [outgoing_account] VARCHAR(50),";
					$access_sql .= "  [show_for_user] INTEGER ";
					$access_sql .= "  ,PRIMARY KEY (dep_id))";
					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];


					$mysql_sql   = "CREATE TABLE " . $table_prefix . "support_predefined (";
					$mysql_sql  .= "  `reply_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `subject` VARCHAR(255),";
					$mysql_sql  .= "  `body` TEXT,";
					$mysql_sql  .= "  `reply_type` VARCHAR(255)";
					$mysql_sql  .= "  ,PRIMARY KEY (reply_id))";
					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "support_predefined START 1";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "support_predefined (";
					$postgre_sql .= "  reply_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "support_predefined'),";
					$postgre_sql .= "  subject VARCHAR(255),";
					$postgre_sql .= "  body TEXT,";
					$postgre_sql .= "  reply_type VARCHAR(255)";
					$postgre_sql .= "  ,PRIMARY KEY (reply_id))";
					$access_sql  = "CREATE TABLE " . $table_prefix . "support_predefined (";
					$access_sql .= "  [reply_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [subject] VARCHAR(255),";
					$access_sql .= "  [body] LONGTEXT,";
					$access_sql .= "  [reply_type] VARCHAR(255)";
					$access_sql .= "  ,PRIMARY KEY (reply_id))";
					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];


					$mysql_sql   = "CREATE TABLE " . $table_prefix . "support_time_report (";
					$mysql_sql  .= "  `report_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `admin_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `support_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `started_date` DATETIME,";
					$mysql_sql  .= "  `report_date` DATETIME,";
					$mysql_sql  .= "  `spent_hours` INT(11) default '0'";
					$mysql_sql  .= "  ,PRIMARY KEY (report_id)";
					$mysql_sql  .= "  ,KEY admin_id (admin_id)";
					$mysql_sql  .= "  ,KEY support_id (support_id))";
					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "support_time_report START 1";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "support_time_report (";
					$postgre_sql .= "  report_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "support_time_report'),";
					$postgre_sql .= "  admin_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  support_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  started_date TIMESTAMP,";
					$postgre_sql .= "  report_date TIMESTAMP,";
					$postgre_sql .= "  spent_hours INT4 default '0'";
					$postgre_sql .= "  ,PRIMARY KEY (report_id))";
					$access_sql  = "CREATE TABLE " . $table_prefix . "support_time_report (";
					$access_sql .= "  [report_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [admin_id] INTEGER,";
					$access_sql .= "  [support_id] INTEGER,";
					$access_sql .= "  [started_date] DATETIME,";
					$access_sql .= "  [report_date] DATETIME,";
					$access_sql .= "  [spent_hours] INTEGER";
					$access_sql .= "  ,PRIMARY KEY (report_id))";
					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];


					$mysql_sql   = "CREATE TABLE " . $table_prefix . "support_users_departments (";
					$mysql_sql  .= "  `admin_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `dep_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `is_default_dep` INT(11) default '0'";
					$mysql_sql  .= "  ,KEY admin_id (admin_id)";
					$mysql_sql  .= "  ,KEY dep_id (dep_id)";
					$mysql_sql  .= "  ,PRIMARY KEY (admin_id,dep_id))";
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "support_users_departments (";
					$postgre_sql .= "  admin_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  dep_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  is_default_dep INT4 default '0'";
					$postgre_sql .= "  ,PRIMARY KEY (admin_id,dep_id))";
					$access_sql  = "CREATE TABLE " . $table_prefix . "support_users_departments (";
					$access_sql .= "  [admin_id] INTEGER NOT NULL,";
					$access_sql .= "  [dep_id] INTEGER NOT NULL,";
					$access_sql .= "  [is_default_dep] INTEGER";
					$access_sql .= "  ,PRIMARY KEY (admin_id,dep_id))";
					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support ADD COLUMN `dep_id` INT(11) NOT NULL default '0' AFTER support_type_id ",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support ADD COLUMN dep_id INT4 NOT NULL default '0'",
						"access" => "ALTER TABLE " . $table_prefix . "support ADD COLUMN [dep_id] INTEGER"
					);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN `dep_id` INT(11) NOT NULL default '0' AFTER support_id",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN dep_id INT4 NOT NULL default '0'",
						"access" => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN [dep_id] INTEGER"
					);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN status_caption VARCHAR(255)",
						"postgre" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN status_caption VARCHAR(255)",
						"access"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN status_caption VARCHAR(255)"
					);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN `is_user_new` INT(11) NOT NULL default '0' ",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_user_new INT4 NOT NULL default '0'",
						"access" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN [is_user_new] INTEGER"
					);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN `is_user_reply` INT(11) NOT NULL default '0' ",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_user_reply INT4 NOT NULL default '0'",
						"access" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN [is_user_reply] INTEGER"
					);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN `is_operation` INT(11) NOT NULL default '0' ",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_operation INT4 NOT NULL default '0'",
						"access" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN [is_operation] INTEGER"
					);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN `is_reassign` INT(11) NOT NULL default '0' ",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_reassign INT4 NOT NULL default '0'",
						"access" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN [is_reassign] INTEGER"
					);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN `is_internal` INT(11) NOT NULL default '0' ",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_internal INT4 NOT NULL default '0'",
						"access" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN [is_internal] INTEGER"
					);
					$sqls[] = $sql_types[$db_type];


					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN `is_list` INT(11) NOT NULL default '0' ",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_list INT4 NOT NULL default '0'",
						"access" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN [is_list] INTEGER"
					);
					$sqls[] = $sql_types[$db_type];

					$sqls[] = " INSERT INTO " . $table_prefix . "support_departments (dep_id, short_title, full_title, show_for_user) VALUES (1, 'Support', 'Support', 1)";
					$sqls[] = " UPDATE " . $table_prefix . "support SET dep_id=1";
					$sqls[] = " UPDATE " . $table_prefix . "support_messages SET dep_id=1";
					$sqls[] = " UPDATE " . $table_prefix . "support_statuses SET status_caption=status_name ";
					$sqls[] = " UPDATE " . $table_prefix . "support_statuses SET is_user_new=1 WHERE status_id=1";
					$sqls[] = " UPDATE " . $table_prefix . "support_statuses SET is_operation=1 ";
					$sqls[] = " UPDATE " . $table_prefix . "support_statuses SET is_list=1 ";
				}

			}
			
			if (comp_vers("2.1.7", $current_db_version) == 1) {
				$mysql_sql   = "CREATE TABLE " . $table_prefix . "coupons (";
				$mysql_sql  .= "  `coupon_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `coupon_code` VARCHAR(64),";
				$mysql_sql  .= "  `coupon_title` VARCHAR(255),";
				$mysql_sql  .= "  `is_active` INT(11) default '1',";
				$mysql_sql  .= "  `discount_type` INT(11) default '0',";
				$mysql_sql  .= "  `discount_amount` FLOAT(10,2) default '0',";
				$mysql_sql  .= "  `free_postage` INT(11) default '0',";
				$mysql_sql  .= "  `tax_free` INT(11) default '0',";
				$mysql_sql  .= "  `items_all` INT(11) default '1',";
				$mysql_sql  .= "  `items_ids` TEXT,";
				$mysql_sql  .= "  `users_ids` TEXT,";
				$mysql_sql  .= "  `minimum_amount` FLOAT(10,2) default '0',";
				$mysql_sql  .= "  `expiry_date` DATETIME,";
				$mysql_sql  .= "  `is_exclusive` INT(11) default '0',";
				$mysql_sql  .= "  `quantity_limit` INT(11) default '1',";
				$mysql_sql  .= "  `coupon_uses` INT(11) default '0'";
				$mysql_sql  .= "  ,KEY coupon_code (coupon_code)";
				$mysql_sql  .= "  ,KEY coupon_id (coupon_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (coupon_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "coupons START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "coupons (";
				$postgre_sql .= "  coupon_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "coupons'),";
				$postgre_sql .= "  coupon_code VARCHAR(64),";
				$postgre_sql .= "  coupon_title VARCHAR(255),";
				$postgre_sql .= "  is_active INT4 default '1',";
				$postgre_sql .= "  discount_type INT4 default '0',";
				$postgre_sql .= "  discount_amount FLOAT4 default '0',";
				$postgre_sql .= "  free_postage INT4 default '0',";
				$postgre_sql .= "  tax_free INT4 default '0',";
				$postgre_sql .= "  items_all INT4 default '1',";
				$postgre_sql .= "  items_ids TEXT,";
				$postgre_sql .= "  users_ids TEXT,";
				$postgre_sql .= "  minimum_amount FLOAT4 default '0',";
				$postgre_sql .= "  expiry_date TIMESTAMP,";
				$postgre_sql .= "  is_exclusive INT4 default '0',";
				$postgre_sql .= "  quantity_limit INT4 default '1',";
				$postgre_sql .= "  coupon_uses INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (coupon_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "coupons (";
				$access_sql .= "  [coupon_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [coupon_code] VARCHAR(64),";
				$access_sql .= "  [coupon_title] VARCHAR(255),";
				$access_sql .= "  [is_active] INTEGER,";
				$access_sql .= "  [discount_type] INTEGER,";
				$access_sql .= "  [discount_amount] FLOAT,";
				$access_sql .= "  [free_postage] INTEGER,";
				$access_sql .= "  [tax_free] INTEGER,";
				$access_sql .= "  [items_all] INTEGER,";
				$access_sql .= "  [items_ids] LONGTEXT,";
				$access_sql .= "  [users_ids] LONGTEXT,";
				$access_sql .= "  [minimum_amount] FLOAT,";
				$access_sql .= "  [expiry_date] DATETIME,";
				$access_sql .= "  [is_exclusive] INTEGER,";
				$access_sql .= "  [quantity_limit] INTEGER,";
				$access_sql .= "  [coupon_uses] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (coupon_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN coupons_ids TEXT AFTER affiliate_code",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN coupons_ids TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN coupons_ids LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN coupons_ids TEXT AFTER item_type_id",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN coupons_ids TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN coupons_ids LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN real_price FLOAT(10,2) default '0' AFTER buying_price",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN real_price FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN real_price FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN discount_amount FLOAT(10,2) default '0' AFTER real_price",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN discount_amount FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN discount_amount FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) ";
				$sql .= " VALUES ('global', 'coupons_enable', '1') ";
				$sqls[] = $sql;

			}

			if (comp_vers("2.1.8", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_parameters ADD COLUMN `not_passed` INT(11) NOT NULL default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "payment_parameters ADD COLUMN not_passed INT4 NOT NULL default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "payment_parameters ADD COLUMN [not_passed] INTEGER" 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `is_advanced` INT(11) NOT NULL default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN is_advanced INT4 NOT NULL default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [is_advanced] INTEGER" 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `advanced_url` VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN advanced_url VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [advanced_url] VARCHAR(255) " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `response_type` VARCHAR(64) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN response_type VARCHAR(64) ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [response_type] VARCHAR(64) " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `response_delimiter` VARCHAR(64) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN response_delimiter VARCHAR(64) ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [response_delimiter] VARCHAR(64) " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `status_parameter` VARCHAR(64) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN status_parameter VARCHAR(64) ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [status_parameter] VARCHAR(64) " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `status_success_regexp` VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN status_success_regexp VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [status_success_regexp] VARCHAR(255) " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `success_status_id` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN success_status_id INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [success_status_id] INTEGER " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `failure_status_id` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN failure_status_id INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [failure_status_id] INTEGER " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `status_message_parameter` VARCHAR(64) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN status_message_parameter VARCHAR(64) ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [status_message_parameter] VARCHAR(64) " 
				);
				$sqls[] = $sql_types[$db_type];
			}

			if (comp_vers("2.1.9", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "polls ADD COLUMN `total_votes` INT(11) NOT NULL default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "polls ADD COLUMN total_votes INT4 NOT NULL default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "polls ADD COLUMN [total_votes] INTEGER" 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "polls_options ADD COLUMN `is_default_value` INT(11) NOT NULL default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "polls_options ADD COLUMN is_default_value INT4 NOT NULL default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "polls_options ADD COLUMN [is_default_value] INTEGER" 
				);
				$sqls[] = $sql_types[$db_type];
			}

			if (comp_vers("2.1.10", $current_db_version) == 1) {
				$mysql_sql   = "CREATE TABLE " . $table_prefix . "currencies (";
				$mysql_sql  .= "  `currency_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `is_default` INT(11) default '0',";
				$mysql_sql  .= "  `currency_title` VARCHAR(64),";
				$mysql_sql  .= "  `currency_code` VARCHAR(4),";
				$mysql_sql  .= "  `exchange_rate` FLOAT(10,8) NOT NULL default '1',";
				$mysql_sql  .= "  `symbol_left` VARCHAR(32),";
				$mysql_sql  .= "  `symbol_right` VARCHAR(32)";
				$mysql_sql  .= "  ,KEY currency_code (currency_code)";
				$mysql_sql  .= "  ,PRIMARY KEY (currency_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "currencies START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "currencies (";
				$postgre_sql .= "  currency_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "currencies'),";
				$postgre_sql .= "  is_default INT4 default '0',";
				$postgre_sql .= "  currency_title VARCHAR(64),";
				$postgre_sql .= "  currency_code VARCHAR(4),";
				$postgre_sql .= "  exchange_rate FLOAT4 NOT NULL default '1',";
				$postgre_sql .= "  symbol_left VARCHAR(32),";
				$postgre_sql .= "  symbol_right VARCHAR(32)";
				$postgre_sql .= "  ,PRIMARY KEY (currency_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "currencies (";
				$access_sql .= "  [currency_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [is_default] INTEGER,";
				$access_sql .= "  [currency_title] VARCHAR(64),";
				$access_sql .= "  [currency_code] VARCHAR(4),";
				$access_sql .= "  [exchange_rate] FLOAT,";
				$access_sql .= "  [symbol_left] VARCHAR(32),";
				$access_sql .= "  [symbol_right] VARCHAR(32)";
				$access_sql .= "  ,PRIMARY KEY (currency_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$currency_sign = ""; $currency_position = 1;
				$sql = "SELECT setting_value FROM " . $table_prefix . "global_settings WHERE setting_name='currency_sign'";
				$db->query($sql);
				if ($db->next_record()) {
					$currency_sign = $db->f("setting_value");
					$sql = "SELECT setting_value FROM " . $table_prefix . "global_settings WHERE setting_name='currency_position'";
					$db->query($sql);
					if ($db->next_record()) {
						$currency_position = $db->f("setting_value");
					} 
				}
				$symbol_left = ""; $symbol_right = "";
				if ($currency_position == 2) {
					$symbol_right = $currency_sign;
				} else {
					$symbol_left = $currency_sign;
				}

				$sql  = " INSERT INTO " . $table_prefix . "currencies (is_default, currency_title, "; 
				$sql .= " currency_code, exchange_rate, symbol_left, symbol_right) VALUES (";
				$sql .= "1, 'Default Currency', 'DEF', 1,";
				$sql .= $db->tosql($symbol_left, TEXT) . ", ";
				$sql .= $db->tosql($symbol_right, TEXT) . ") ";
				$sqls[] = $sql;
			}

			if (comp_vers("2.2", $current_db_version) == 1) {
				if (VA_TYPE == "enterprise" || VA_TYPE == "standard") {
					$mysql_sql   = "CREATE TABLE " . $table_prefix . "articles (";
					$mysql_sql  .= "  `article_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `language_code` VARCHAR(2),";
					$mysql_sql  .= "  `article_date` DATETIME,";
					$mysql_sql  .= "  `date_end` DATETIME,";
					$mysql_sql  .= "  `article_title` VARCHAR(255),";
					$mysql_sql  .= "  `article_template` VARCHAR(255),";
					$mysql_sql  .= "  `article_order` INT(11) default '0',";
					$mysql_sql  .= "  `author_name` VARCHAR(255),";
					$mysql_sql  .= "  `author_email` VARCHAR(255),";
					$mysql_sql  .= "  `author_url` VARCHAR(255),";
					$mysql_sql  .= "  `author_remote_address` VARCHAR(255),";
					$mysql_sql  .= "  `created_user_id` INT(11) default '0',";
					$mysql_sql  .= "  `created_admin_id` INT(11) default '0',";
					$mysql_sql  .= "  `updated_user_id` INT(11) default '0',";
					$mysql_sql  .= "  `updated_admin_id` INT(11) default '0',";
					$mysql_sql  .= "  `status_id` INT(11) default '0',";
					$mysql_sql  .= "  `is_html` INT(11) default '0',";
					$mysql_sql  .= "  `allowed_rate` VARCHAR(50),";
					$mysql_sql  .= "  `is_hot` INT(11) default '0',";
					$mysql_sql  .= "  `link_url` VARCHAR(255),";
					$mysql_sql  .= "  `download_url` VARCHAR(255),";
					$mysql_sql  .= "  `is_link_direct` VARCHAR(255),";
					$mysql_sql  .= "  `date_added` VARCHAR(255),";
					$mysql_sql  .= "  `date_updated` VARCHAR(255),";
					$mysql_sql  .= "  `keywords` TEXT,";
					$mysql_sql  .= "  `hot_description` TEXT,";
					$mysql_sql  .= "  `short_description` TEXT,";
					$mysql_sql  .= "  `full_description` TEXT,";
					$mysql_sql  .= "  `notes` TEXT,";
					$mysql_sql  .= "  `total_views` INT(11) default '0',";
					$mysql_sql  .= "  `total_votes` INT(11) default '0',";
					$mysql_sql  .= "  `total_points` INT(11) default '0',";
					$mysql_sql  .= "  `rating` FLOAT(10,2) default '0',";
					$mysql_sql  .= "  `total_clicks` INT(11) default '0',";
					$mysql_sql  .= "  `image_small` VARCHAR(255),";
					$mysql_sql  .= "  `image_large` VARCHAR(255)";
					$mysql_sql  .= "  ,KEY article_id (article_id)";
					$mysql_sql  .= "  ,KEY language_code (language_code)";
					$mysql_sql  .= "  ,PRIMARY KEY (article_id))";

					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "articles START 1";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "articles (";
					$postgre_sql .= "  article_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "articles'),";
					$postgre_sql .= "  language_code VARCHAR(2),";
					$postgre_sql .= "  article_date TIMESTAMP,";
					$postgre_sql .= "  date_end TIMESTAMP,";
					$postgre_sql .= "  article_title VARCHAR(255),";
					$postgre_sql .= "  article_template VARCHAR(255),";
					$postgre_sql .= "  article_order INT4 default '0',";
					$postgre_sql .= "  author_name VARCHAR(255),";
					$postgre_sql .= "  author_email VARCHAR(255),";
					$postgre_sql .= "  author_url VARCHAR(255),";
					$postgre_sql .= "  author_remote_address VARCHAR(255),";
					$postgre_sql .= "  created_user_id INT4 default '0',";
					$postgre_sql .= "  created_admin_id INT4 default '0',";
					$postgre_sql .= "  updated_user_id INT4 default '0',";
					$postgre_sql .= "  updated_admin_id INT4 default '0',";
					$postgre_sql .= "  status_id INT4 default '0',";
					$postgre_sql .= "  is_html INT4 default '0',";
					$postgre_sql .= "  allowed_rate VARCHAR(50),";
					$postgre_sql .= "  is_hot INT4 default '0',";
					$postgre_sql .= "  link_url VARCHAR(255),";
					$postgre_sql .= "  download_url VARCHAR(255),";
					$postgre_sql .= "  is_link_direct VARCHAR(255),";
					$postgre_sql .= "  date_added VARCHAR(255),";
					$postgre_sql .= "  date_updated VARCHAR(255),";
					$postgre_sql .= "  keywords TEXT,";
					$postgre_sql .= "  hot_description TEXT,";
					$postgre_sql .= "  short_description TEXT,";
					$postgre_sql .= "  full_description TEXT,";
					$postgre_sql .= "  notes TEXT,";
					$postgre_sql .= "  total_views INT4 default '0',";
					$postgre_sql .= "  total_votes INT4 default '0',";
					$postgre_sql .= "  total_points INT4 default '0',";
					$postgre_sql .= "  rating FLOAT4 default '0',";
					$postgre_sql .= "  total_clicks INT4 default '0',";
					$postgre_sql .= "  image_small VARCHAR(255),";
					$postgre_sql .= "  image_large VARCHAR(255)";
					$postgre_sql .= "  ,PRIMARY KEY (article_id))";

					$access_sql  = "CREATE TABLE " . $table_prefix . "articles (";
					$access_sql .= "  [article_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [language_code] VARCHAR(2),";
					$access_sql .= "  [article_date] DATETIME,";
					$access_sql .= "  [date_end] DATETIME,";
					$access_sql .= "  [article_title] VARCHAR(255),";
					$access_sql .= "  [article_template] VARCHAR(255),";
					$access_sql .= "  [article_order] INTEGER,";
					$access_sql .= "  [author_name] VARCHAR(255),";
					$access_sql .= "  [author_email] VARCHAR(255),";
					$access_sql .= "  [author_url] VARCHAR(255),";
					$access_sql .= "  [author_remote_address] VARCHAR(255),";
					$access_sql .= "  [created_user_id] INTEGER,";
					$access_sql .= "  [created_admin_id] INTEGER,";
					$access_sql .= "  [updated_user_id] INTEGER,";
					$access_sql .= "  [updated_admin_id] INTEGER,";
					$access_sql .= "  [status_id] INTEGER,";
					$access_sql .= "  [is_html] INTEGER,";
					$access_sql .= "  [allowed_rate] VARCHAR(50),";
					$access_sql .= "  [is_hot] INTEGER,";
					$access_sql .= "  [link_url] VARCHAR(255),";
					$access_sql .= "  [download_url] VARCHAR(255),";
					$access_sql .= "  [is_link_direct] VARCHAR(255),";
					$access_sql .= "  [date_added] VARCHAR(255),";
					$access_sql .= "  [date_updated] VARCHAR(255),";
					$access_sql .= "  [keywords] LONGTEXT,";
					$access_sql .= "  [hot_description] LONGTEXT,";
					$access_sql .= "  [short_description] LONGTEXT,";
					$access_sql .= "  [full_description] LONGTEXT,";
					$access_sql .= "  [notes] LONGTEXT,";
					$access_sql .= "  [total_views] INTEGER,";
					$access_sql .= "  [total_votes] INTEGER,";
					$access_sql .= "  [total_points] INTEGER,";
					$access_sql .= "  [rating] FLOAT,";
					$access_sql .= "  [total_clicks] INTEGER,";
					$access_sql .= "  [image_small] VARCHAR(255),";
					$access_sql .= "  [image_large] VARCHAR(255)";
					$access_sql .= "  ,PRIMARY KEY (article_id))";

					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];

					$mysql_sql   = "CREATE TABLE " . $table_prefix . "articles_assigned (";
					$mysql_sql  .= "  `article_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `category_id` INT(11) NOT NULL default '0'";
					$mysql_sql  .= "  ,PRIMARY KEY (article_id,category_id))";

					$postgre_sql  = "CREATE TABLE " . $table_prefix . "articles_assigned (";
					$postgre_sql .= "  article_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  category_id INT4 NOT NULL default '0'";
					$postgre_sql .= "  ,PRIMARY KEY (article_id,category_id))";

					$access_sql  = "CREATE TABLE " . $table_prefix . "articles_assigned (";
					$access_sql .= "  [article_id] INTEGER NOT NULL,";
					$access_sql .= "  [category_id] INTEGER NOT NULL";
					$access_sql .= "  ,PRIMARY KEY (article_id,category_id))";

					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];

					$mysql_sql   = "CREATE TABLE " . $table_prefix . "articles_categories (";
					$mysql_sql  .= "  `category_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `language_code` VARCHAR(2),";
					$mysql_sql  .= "  `parent_category_id` INT(11) default '0',";
					$mysql_sql  .= "  `alias_category_id` INT(11) default '0',";
					$mysql_sql  .= "  `category_path` VARCHAR(255) NOT NULL DEFAULT '',";
					$mysql_sql  .= "  `category_name` VARCHAR(255),";
					$mysql_sql  .= "  `category_order` INT(11) default '0',";
					$mysql_sql  .= "  `articles_list_template` VARCHAR(255),";
					$mysql_sql  .= "  `articles_details_template` VARCHAR(255),";
					$mysql_sql  .= "  `articles_order_column` VARCHAR(50),";
					$mysql_sql  .= "  `articles_order_direction` VARCHAR(50),";
					$mysql_sql  .= "  `article_list_fields` TEXT,";
					$mysql_sql  .= "  `article_details_fields` TEXT,";
					$mysql_sql  .= "  `article_required_fields` TEXT,";
					$mysql_sql  .= "  `moderators_ids` VARCHAR(255),";
					$mysql_sql  .= "  `is_hot` INT(11) default '0',";
					$mysql_sql  .= "  `allowed_view` INT(11) default '0',";
					$mysql_sql  .= "  `allowed_post` INT(11) default '0',";
					$mysql_sql  .= "  `allowed_rate` INT(11) default '0',";
					$mysql_sql  .= "  `short_description` TEXT,";
					$mysql_sql  .= "  `full_description` TEXT,";
					$mysql_sql  .= "  `image_small` VARCHAR(255),";
					$mysql_sql  .= "  `image_large` VARCHAR(255),";
					$mysql_sql  .= "  `total_articles` INT(11) default '0',";
					$mysql_sql  .= "  `total_subcategories` INT(11) default '0'";
					$mysql_sql  .= "  ,KEY category_path (category_path)";
					$mysql_sql  .= "  ,KEY parent_category_id (parent_category_id)";
					$mysql_sql  .= "  ,PRIMARY KEY (category_id))";

					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "articles_categories START 1";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "articles_categories (";
					$postgre_sql .= "  category_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "articles_categories'),";
					$postgre_sql .= "  language_code VARCHAR(2),";
					$postgre_sql .= "  parent_category_id INT4 default '0',";
					$postgre_sql .= "  alias_category_id INT4 default '0',";
					$postgre_sql .= "  category_path VARCHAR(255) NOT NULL DEFAULT '',";
					$postgre_sql .= "  category_name VARCHAR(255),";
					$postgre_sql .= "  category_order INT4 default '0',";
					$postgre_sql .= "  articles_list_template VARCHAR(255),";
					$postgre_sql .= "  articles_details_template VARCHAR(255),";
					$postgre_sql .= "  articles_order_column VARCHAR(50),";
					$postgre_sql .= "  articles_order_direction VARCHAR(50),";
					$postgre_sql .= "  article_list_fields TEXT,";
					$postgre_sql .= "  article_details_fields TEXT,";
					$postgre_sql .= "  article_required_fields TEXT,";
					$postgre_sql .= "  moderators_ids VARCHAR(255),";
					$postgre_sql .= "  is_hot INT4 default '0',";
					$postgre_sql .= "  allowed_view INT4 default '0',";
					$postgre_sql .= "  allowed_post INT4 default '0',";
					$postgre_sql .= "  allowed_rate INT4 default '0',";
					$postgre_sql .= "  short_description TEXT,";
					$postgre_sql .= "  full_description TEXT,";
					$postgre_sql .= "  image_small VARCHAR(255),";
					$postgre_sql .= "  image_large VARCHAR(255),";
					$postgre_sql .= "  total_articles INT4 default '0',";
					$postgre_sql .= "  total_subcategories INT4 default '0'";
					$postgre_sql .= "  ,PRIMARY KEY (category_id))";

					$access_sql  = "CREATE TABLE " . $table_prefix . "articles_categories (";
					$access_sql .= "  [category_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [language_code] VARCHAR(2),";
					$access_sql .= "  [parent_category_id] INTEGER,";
					$access_sql .= "  [alias_category_id] INTEGER,";
					$access_sql .= "  [category_path] VARCHAR(255),";
					$access_sql .= "  [category_name] VARCHAR(255),";
					$access_sql .= "  [category_order] INTEGER,";
					$access_sql .= "  [articles_list_template] VARCHAR(255),";
					$access_sql .= "  [articles_details_template] VARCHAR(255),";
					$access_sql .= "  [articles_order_column] VARCHAR(50),";
					$access_sql .= "  [articles_order_direction] VARCHAR(50),";
					$access_sql .= "  [article_list_fields] LONGTEXT,";
					$access_sql .= "  [article_details_fields] LONGTEXT,";
					$access_sql .= "  [article_required_fields] LONGTEXT,";
					$access_sql .= "  [moderators_ids] VARCHAR(255),";
					$access_sql .= "  [is_hot] INTEGER,";
					$access_sql .= "  [allowed_view] INTEGER,";
					$access_sql .= "  [allowed_post] INTEGER,";
					$access_sql .= "  [allowed_rate] INTEGER,";
					$access_sql .= "  [short_description] LONGTEXT,";
					$access_sql .= "  [full_description] LONGTEXT,";
					$access_sql .= "  [image_small] VARCHAR(255),";
					$access_sql .= "  [image_large] VARCHAR(255),";
					$access_sql .= "  [total_articles] INTEGER,";
					$access_sql .= "  [total_subcategories] INTEGER";
					$access_sql .= "  ,PRIMARY KEY (category_id))";

					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];

					if ($db_type == "postgre" || $db_type == "access") {
						$sqls[] = "CREATE INDEX " . $table_prefix . "articles_categories_parent_category_id ON " . $table_prefix . "articles_categories (parent_category_id)";
						$sqls[] = "CREATE INDEX " . $table_prefix . "articles_categories_category_path ON " . $table_prefix . "articles_categories (category_path)";
					} 

					$mysql_sql   = "CREATE TABLE " . $table_prefix . "articles_images (";
					$mysql_sql  .= "  `image_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `article_id` INT(11) default '0',";
					$mysql_sql  .= "  `image_name` VARCHAR(255),";
					$mysql_sql  .= "  `image_title` VARCHAR(255),";
					$mysql_sql  .= "  `image_width` VARCHAR(255),";
					$mysql_sql  .= "  `image_height` VARCHAR(255),";
					$mysql_sql  .= "  `image_alt` VARCHAR(255),";
					$mysql_sql  .= "  `image_align` VARCHAR(255),";
					$mysql_sql  .= "  `date_added` DATETIME";
					$mysql_sql  .= "  ,KEY article_id (article_id)";
					$mysql_sql  .= "  ,PRIMARY KEY (image_id))";

					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "articles_images START 1";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "articles_images (";
					$postgre_sql .= "  image_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "articles_images'),";
					$postgre_sql .= "  article_id INT4 default '0',";
					$postgre_sql .= "  image_name VARCHAR(255),";
					$postgre_sql .= "  image_title VARCHAR(255),";
					$postgre_sql .= "  image_width VARCHAR(255),";
					$postgre_sql .= "  image_height VARCHAR(255),";
					$postgre_sql .= "  image_alt VARCHAR(255),";
					$postgre_sql .= "  image_align VARCHAR(255),";
					$postgre_sql .= "  date_added TIMESTAMP";
					$postgre_sql .= "  ,PRIMARY KEY (image_id))";

					$access_sql  = "CREATE TABLE " . $table_prefix . "articles_images (";
					$access_sql .= "  [image_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [article_id] INTEGER,";
					$access_sql .= "  [image_name] VARCHAR(255),";
					$access_sql .= "  [image_title] VARCHAR(255),";
					$access_sql .= "  [image_width] VARCHAR(255),";
					$access_sql .= "  [image_height] VARCHAR(255),";
					$access_sql .= "  [image_alt] VARCHAR(255),";
					$access_sql .= "  [image_align] VARCHAR(255),";
					$access_sql .= "  [date_added] DATETIME";
					$access_sql .= "  ,PRIMARY KEY (image_id))";

					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];

					if($db_type == "postgre" || $db_type == "access") {
						$sqls[] = "CREATE INDEX " . $table_prefix . "articles_images_article_id ON " . $table_prefix . "articles_images (article_id)";
					}

					$mysql_sql   = "CREATE TABLE " . $table_prefix . "articles_related (";
					$mysql_sql  .= "  `article_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `related_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `related_order` INT(11) NOT NULL default '1'";
					$mysql_sql  .= "  ,PRIMARY KEY (article_id,related_id))";

					$postgre_sql  = "CREATE TABLE " . $table_prefix . "articles_related (";
					$postgre_sql .= "  article_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  related_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  related_order INT4 NOT NULL default '1'";
					$postgre_sql .= "  ,PRIMARY KEY (article_id,related_id))";

					$access_sql  = "CREATE TABLE " . $table_prefix . "articles_related (";
					$access_sql .= "  [article_id] INTEGER NOT NULL,";
					$access_sql .= "  [related_id] INTEGER NOT NULL,";
					$access_sql .= "  [related_order] INTEGER";
					$access_sql .= "  ,PRIMARY KEY (article_id,related_id))";

					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];

					$mysql_sql   = "CREATE TABLE " . $table_prefix . "articles_reviews (";
					$mysql_sql  .= "  `review_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `article_id` INT(11) NOT NULL default '0',";
					$mysql_sql  .= "  `recommended` INT(11) default '0',";
					$mysql_sql  .= "  `approved` INT(11) default '0',";
					$mysql_sql  .= "  `rating` INT(11) default '0',";
					$mysql_sql  .= "  `summary` TEXT,";
					$mysql_sql  .= "  `user_name` VARCHAR(255),";
					$mysql_sql  .= "  `remote_address` VARCHAR(255),";
					$mysql_sql  .= "  `date_added` DATETIME,";
					$mysql_sql  .= "  `comments` TEXT";
					$mysql_sql  .= "  ,KEY article_id (article_id)";
					$mysql_sql  .= "  ,PRIMARY KEY (review_id))";

					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "articles_reviews START 1";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "articles_reviews (";
					$postgre_sql .= "  review_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "articles_reviews'),";
					$postgre_sql .= "  article_id INT4 NOT NULL default '0',";
					$postgre_sql .= "  recommended INT4 default '0',";
					$postgre_sql .= "  approved INT4 default '0',";
					$postgre_sql .= "  rating INT4 default '0',";
					$postgre_sql .= "  summary TEXT,";
					$postgre_sql .= "  user_name VARCHAR(255),";
					$postgre_sql .= "  remote_address VARCHAR(255),";
					$postgre_sql .= "  date_added TIMESTAMP,";
					$postgre_sql .= "  comments TEXT";
					$postgre_sql .= "  ,PRIMARY KEY (review_id))";

					$access_sql  = "CREATE TABLE " . $table_prefix . "articles_reviews (";
					$access_sql .= "  [review_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [article_id] INTEGER,";
					$access_sql .= "  [recommended] INTEGER,";
					$access_sql .= "  [approved] INTEGER,";
					$access_sql .= "  [rating] INTEGER,";
					$access_sql .= "  [summary] LONGTEXT,";
					$access_sql .= "  [user_name] VARCHAR(255),";
					$access_sql .= "  [remote_address] VARCHAR(255),";
					$access_sql .= "  [date_added] DATETIME,";
					$access_sql .= "  [comments] LONGTEXT";
					$access_sql .= "  ,PRIMARY KEY (review_id))";

					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];

					if ($db_type == "postgre" || $db_type == "access") {
						$sqls[] = "CREATE INDEX " . $table_prefix . "articles_reviews_article_id ON " . $table_prefix . "articles_reviews (article_id)";
					} 

					$mysql_sql   = "CREATE TABLE " . $table_prefix . "articles_statuses (";
					$mysql_sql  .= "  `status_id` INT(11) NOT NULL AUTO_INCREMENT,";
					$mysql_sql  .= "  `status_name` VARCHAR(255),";
					$mysql_sql  .= "  `status_description` VARCHAR(255),";
					$mysql_sql  .= "  `is_shown` INT(11) default '0',";
					$mysql_sql  .= "  `status_icon` VARCHAR(255),";
					$mysql_sql  .= "  `status_style` VARCHAR(255),";
					$mysql_sql  .= "  `allowed_view` INT(11) default '0'";
					$mysql_sql  .= "  ,PRIMARY KEY (status_id))";

					if($db_type == "postgre") {
						$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "articles_statuses START 5";
					}
					$postgre_sql  = "CREATE TABLE " . $table_prefix . "articles_statuses (";
					$postgre_sql .= "  status_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "articles_statuses'),";
					$postgre_sql .= "  status_name VARCHAR(255),";
					$postgre_sql .= "  status_description VARCHAR(255),";
					$postgre_sql .= "  is_shown INT4 default '0',";
					$postgre_sql .= "  status_icon VARCHAR(255),";
					$postgre_sql .= "  status_style VARCHAR(255),";
					$postgre_sql .= "  allowed_view INT4 default '0'";
					$postgre_sql .= "  ,PRIMARY KEY (status_id))";

					$access_sql  = "CREATE TABLE " . $table_prefix . "articles_statuses (";
					$access_sql .= "  [status_id]  COUNTER  NOT NULL,";
					$access_sql .= "  [status_name] VARCHAR(255),";
					$access_sql .= "  [status_description] VARCHAR(255),";
					$access_sql .= "  [is_shown] INTEGER,";
					$access_sql .= "  [status_icon] VARCHAR(255),";
					$access_sql .= "  [status_style] VARCHAR(255),";
					$access_sql .= "  [allowed_view] INTEGER";
					$access_sql .= "  ,PRIMARY KEY (status_id))";

					$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
					$sqls[] = $sql_types[$db_type];

					$sqls[] = "INSERT INTO " . $table_prefix . "articles_statuses (status_id,status_name,status_description,is_shown,status_icon,status_style,allowed_view) VALUES (1 , 'New' , NULL , 1 , NULL , NULL , 1 )";
					$sqls[] = "INSERT INTO " . $table_prefix . "articles_statuses (status_id,status_name,status_description,is_shown,status_icon,status_style,allowed_view) VALUES (2 , 'Published' , NULL , 1 , NULL , NULL , 1 )";
					$sqls[] = "INSERT INTO " . $table_prefix . "articles_statuses (status_id,status_name,status_description,is_shown,status_icon,status_style,allowed_view) VALUES (3 , 'Pending' , NULL , 1 , NULL , NULL , 0 )";
					$sqls[] = "INSERT INTO " . $table_prefix . "articles_statuses (status_id,status_name,status_description,is_shown,status_icon,status_style,allowed_view) VALUES (4 , 'Hidden' , NULL , 1 , NULL , NULL , 0 )";

					// create news, events and FAQ categories
					$sqls[] = "INSERT INTO " . $table_prefix . "articles_categories (category_id, parent_category_id, category_path, category_name, category_order, articles_order_column, articles_order_direction, article_list_fields, article_details_fields, article_required_fields, allowed_view, allowed_rate) VALUES (1, 0, '0,', 'News', 1, 'article_date', 'DESC', 'article_date,article_title,image_small,short_description', 'article_date,article_title,image_large,full_description', 'article_date,article_title', 1, 0)";
					$sqls[] = "INSERT INTO " . $table_prefix . "articles_categories (category_id, parent_category_id, category_path, category_name, category_order, articles_order_column, articles_order_direction, article_list_fields, article_details_fields, article_required_fields, allowed_view, allowed_rate) VALUES (2, 0, '0,', 'Events', 2, 'article_date', 'DESC', 'article_date,date_end,article_title,image_small,short_description','article_date,date_end,article_title,image_large,full_description', 'article_date,date_end,article_title', 1, 0)";
					$sqls[] = "INSERT INTO " . $table_prefix . "articles_categories (category_id, parent_category_id, category_path, category_name, category_order, articles_order_column, articles_order_direction, article_list_fields, article_details_fields, article_required_fields, allowed_view, allowed_rate) VALUES (3, 0, '0,', 'FAQ', 3, 'article_order', 'ASC', 'article_title,full_description', 'article_title,full_description', 'article_title,full_description', 1, 1)";

					// create news list layout
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_1', 'left_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_1', 'left_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_1', 'middle_column_hide', NULL, '0')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_1', 'middle_column_width', NULL, '100%')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_1', 'right_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_1', 'right_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_1', 'a_list_1', 0, 'middle')";

					// create news details layout
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_1', 'left_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_1', 'left_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_1', 'middle_column_hide', NULL, '0')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_1', 'middle_column_width', NULL, '100%')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_1', 'right_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_1', 'right_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_1', 'a_details_1', 0, 'middle')";

					// create events list layout
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_2', 'left_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_2', 'left_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_2', 'middle_column_hide', NULL, '0')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_2', 'middle_column_width', NULL, '100%')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_2', 'right_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_2', 'right_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_2', 'a_list_2', 0, 'middle')";

					// create events details layout
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_2', 'left_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_2', 'left_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_2', 'middle_column_hide', NULL, '0')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_2', 'middle_column_width', NULL, '100%')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_2', 'right_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_2', 'right_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_2', 'a_details_2', 0, 'middle')";

					// create FAQ list layout
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_3', 'left_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_3', 'left_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_3', 'middle_column_hide', NULL, '0')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_3', 'middle_column_width', NULL, '100%')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_3', 'right_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_3', 'right_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_3', 'a_content_3', 0, 'middle')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_list_3', 'a_list_3', 1, 'middle')";

					// create FAQ details layout
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_3', 'left_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_3', 'left_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_3', 'middle_column_hide', NULL, '0')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_3', 'middle_column_width', NULL, '100%')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_3', 'right_column_hide', NULL, '1')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_3', 'right_column_width', NULL, '')";
					$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'a_details_3', 'a_details_3', 0, 'middle')";

					$article_id = 0;
					$article_order = 0;
					$author_remote_address = get_ip("REMOTE_ADDR");
					$session_admin_id = get_session("session_admin_id");
					$date_added = va_time();
					// import News
					$sql = "SELECT * FROM " . $table_prefix . "news ";
					$db->query($sql);
					while ($db->next_record()) {
						$article_id++;
						$article_order++;
						$article_date = $db->f("news_date", DATETIME);
						$article_title = $db->f("news_title");
						$author_name = $db->f("author");
						$is_html = $db->f("is_html");
						$status_id = ($db->f("is_showing") == 1) ? 2 : 4;
						$is_hot = ($db->f("show_on_index") == 1) ? 1 : 0;
						$short_description = $db->f("preview_text");
						$full_description = $db->f("news_body");

						$sql  = " INSERT INTO " . $table_prefix . "articles (article_id,article_order,article_date,article_title,author_name,author_remote_address,is_html,status_id,is_hot,short_description,full_description,total_views,total_votes,total_points,rating,total_clicks,created_admin_id,updated_admin_id,date_added,date_updated) VALUES (";
						$sql .= $db->tosql($article_id, INTEGER) . ", ";
						$sql .= $db->tosql($article_order, INTEGER) . ", ";
						$sql .= $db->tosql($article_date, DATETIME) . ", ";
						$sql .= $db->tosql($article_title, TEXT) . ", ";
						$sql .= $db->tosql($author_name, TEXT) . ", ";
						$sql .= $db->tosql($author_remote_address, TEXT) . ", ";
						$sql .= $db->tosql($is_html, INTEGER) . ", ";
						$sql .= $db->tosql($status_id, INTEGER) . ", ";
						$sql .= $db->tosql($is_hot, INTEGER) . ", ";
						$sql .= $db->tosql($short_description, TEXT) . ", ";
						$sql .= $db->tosql($full_description, TEXT) . ", ";
						$sql .= "0,0,0,0,0, ";
						$sql .= $db->tosql($session_admin_id, INTEGER) . ", ";
						$sql .= $db->tosql($session_admin_id, INTEGER) . ", ";
						$sql .= $db->tosql($date_added, DATETIME) . ", ";
						$sql .= $db->tosql($date_added, DATETIME) . ") ";

						$sqls[] = $sql;
						$sqls[] = " INSERT INTO " . $table_prefix . "articles_assigned (article_id, category_id) VALUES (" . $db->tosql($article_id, INTEGER) . ", 1)";
					}

					// import Events
					$article_order = 0;
					$sql = "SELECT * FROM " . $table_prefix . "events ";
					$db->query($sql);
					while ($db->next_record()) {
						$article_id++;
						$article_order++;
						$article_date = $db->f("event_date", DATETIME);
						$date_end = $article_date;
						$article_title = $db->f("event_title");
						$is_html = $db->f("is_html");
						$status_id = ($db->f("is_showing") == 1) ? 2 : 4;
						$is_hot = ($db->f("show_on_index") == 1) ? 1 : 0;
						$short_description = $db->f("preview_text");
						$full_description = $db->f("event_body");

						$sql  = " INSERT INTO " . $table_prefix . "articles (article_id,article_order,article_date,date_end,article_title,author_remote_address,is_html,status_id,is_hot,short_description,full_description,total_views,total_votes,total_points,rating,total_clicks,created_admin_id,updated_admin_id,date_added,date_updated) VALUES (";
						$sql .= $db->tosql($article_id, INTEGER) . ", ";
						$sql .= $db->tosql($article_order, INTEGER) . ", ";
						$sql .= $db->tosql($article_date, DATETIME) . ", ";
						$sql .= $db->tosql($date_end, DATETIME) . ", ";
						$sql .= $db->tosql($article_title, TEXT) . ", ";
						$sql .= $db->tosql($author_remote_address, TEXT) . ", ";
						$sql .= $db->tosql($is_html, INTEGER) . ", ";
						$sql .= $db->tosql($status_id, INTEGER) . ", ";
						$sql .= $db->tosql($is_hot, INTEGER) . ", ";
						$sql .= $db->tosql($short_description, TEXT) . ", ";
						$sql .= $db->tosql($full_description, TEXT) . ", ";
						$sql .= "0,0,0,0,0, ";
						$sql .= $db->tosql($session_admin_id, INTEGER) . ", ";
						$sql .= $db->tosql($session_admin_id, INTEGER) . ", ";
						$sql .= $db->tosql($date_added, DATETIME) . ", ";
						$sql .= $db->tosql($date_added, DATETIME) . ") ";

						$sqls[] = $sql;
						$sqls[] = " INSERT INTO " . $table_prefix . "articles_assigned (article_id, category_id) VALUES (" . $db->tosql($article_id, INTEGER) . ", 2)";
					}

					// import FAQ
					$sql = "SELECT * FROM " . $table_prefix . "faq ";
					$db->query($sql);
					while ($db->next_record()) {
						$article_id++;
						$article_order = $db->f("faq_order");
						$article_date = $date_added;
						$article_title = $db->f("question");
						$is_html = 0;
						$status_id = 2;
						$is_hot = 0;
						$short_description = "";
						$full_description = $db->f("answer");

						$sql  = " INSERT INTO " . $table_prefix . "articles (article_id,article_order,article_date,article_title,author_remote_address,is_html,status_id,is_hot,short_description,full_description,total_views,total_votes,total_points,rating,total_clicks,created_admin_id,updated_admin_id,date_added,date_updated) VALUES (";
						$sql .= $db->tosql($article_id, INTEGER) . ", ";
						$sql .= $db->tosql($article_order, INTEGER) . ", ";
						$sql .= $db->tosql($article_date, DATETIME) . ", ";
						$sql .= $db->tosql($article_title, TEXT) . ", ";
						$sql .= $db->tosql($author_remote_address, TEXT) . ", ";
						$sql .= $db->tosql($is_html, INTEGER) . ", ";
						$sql .= $db->tosql($status_id, INTEGER) . ", ";
						$sql .= $db->tosql($is_hot, INTEGER) . ", ";
						$sql .= $db->tosql($short_description, TEXT) . ", ";
						$sql .= $db->tosql($full_description, TEXT) . ", ";
						$sql .= "0,0,0,0,0, ";
						$sql .= $db->tosql($session_admin_id, INTEGER) . ", ";
						$sql .= $db->tosql($session_admin_id, INTEGER) . ", ";
						$sql .= $db->tosql($date_added, DATETIME) . ", ";
						$sql .= $db->tosql($date_added, DATETIME) . ") ";

						$sqls[] = $sql;
						$sqls[] = " INSERT INTO " . $table_prefix . "articles_assigned (article_id, category_id) VALUES (" . $db->tosql($article_id, INTEGER) . ", 3)";
					}

					// update header links
					$sqls[] = " UPDATE " . $table_prefix . "header_links SET menu_url='articles.php?category_id=1' WHERE menu_url='news.php'";
					$sqls[] = " UPDATE " . $table_prefix . "header_links SET menu_url='articles.php?category_id=2' WHERE menu_url='events.php'";
					$sqls[] = " UPDATE " . $table_prefix . "header_links SET menu_url='articles.php?category_id=3' WHERE menu_url='faq.php'";

					// update news and events blocks
					$sqls[] = " UPDATE " . $table_prefix . "page_settings SET setting_name='a_hot_1' WHERE setting_name='news_block'";
					$sqls[] = " UPDATE " . $table_prefix . "page_settings SET setting_name='a_hot_2' WHERE setting_name='events_block'";
				}

				// update products list layouts
				$layout_id = get_setting_value($settings, "layout_id");
				if (!strlen($layout_id)) {
					$sql = " SELECT MIN(layout_id) FROM " . $table_prefix . "layouts ";
					$db->query($sql);
					if ($db->next_record()) {
						$layout_id = $db->f("layout_id");
					}
				}
				$sql = "SELECT * FROM " . $table_prefix . "page_settings WHERE page_name='products' AND layout_id=" . $db->tosql($layout_id, INTEGER);
				$db->query($sql);
				while ($db->next_record()) {
					$setting_name = $db->f("setting_name");
					$setting_order = $db->f("setting_order");
					$setting_value = $db->f("setting_value");
					$sql  = " INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'products_list', ";
					$sql .= $db->tosql($setting_name, TEXT, true, false) . ",";
					$sql .= $db->tosql($setting_order, INTEGER) . ",";
					$sql .= $db->tosql($setting_value, TEXT, true, false) . ")";
					$sqls[] = $sql;
				}
				
				$sql = "SELECT * FROM " . $table_prefix . "page_settings WHERE page_name='details' AND layout_id=" . $db->tosql($layout_id, INTEGER);
				$db->query($sql);
				while ($db->next_record()) {
					$setting_name = $db->f("setting_name");
					$setting_order = $db->f("setting_order");
					$setting_value = $db->f("setting_value");
					$sql  = " INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'products_details', ";
					$sql .= $db->tosql($setting_name, TEXT, true, false) . ",";
					$sql .= $db->tosql($setting_order, INTEGER) . ",";
					$sql .= $db->tosql($setting_value, TEXT, true, false) . ")";
					$sqls[] = $sql;
				}

			}

			if (comp_vers("2.2.1", $current_db_version) == 1) {

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "features (";
				$mysql_sql  .= "  `feature_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `item_id` INT(11) default '0',";
				$mysql_sql  .= "  `group_id` INT(11) default '0',";
				$mysql_sql  .= "  `feature_name` VARCHAR(255),";
				$mysql_sql  .= "  `feature_value` VARCHAR(255)";
				$mysql_sql  .= "  ,KEY group_id (group_id)";
				$mysql_sql  .= "  ,KEY item_id (item_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (feature_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "features START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "features (";
				$postgre_sql .= "  feature_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "features'),";
				$postgre_sql .= "  item_id INT4 default '0',";
				$postgre_sql .= "  group_id INT4 default '0',";
				$postgre_sql .= "  feature_name VARCHAR(255),";
				$postgre_sql .= "  feature_value VARCHAR(255)";
				$postgre_sql .= "  ,PRIMARY KEY (feature_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "features (";
				$access_sql .= "  [feature_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [item_id] INTEGER,";
				$access_sql .= "  [group_id] INTEGER,";
				$access_sql .= "  [feature_name] VARCHAR(255),";
				$access_sql .= "  [feature_value] VARCHAR(255)";
				$access_sql .= "  ,PRIMARY KEY (feature_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "features_group_id ON " . $table_prefix . "features (group_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "features_item_id ON " . $table_prefix . "features (item_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "features_default (";
				$mysql_sql  .= "  `feature_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `item_type_id` INT(11) default '0',";
				$mysql_sql  .= "  `group_id` INT(11) default '0',";
				$mysql_sql  .= "  `feature_name` VARCHAR(50),";
				$mysql_sql  .= "  `feature_value` TEXT";
				$mysql_sql  .= "  ,KEY group_id (group_id)";
				$mysql_sql  .= "  ,KEY item_type_id (item_type_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (feature_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "features_default START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "features_default (";
				$postgre_sql .= "  feature_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "features_default'),";
				$postgre_sql .= "  item_type_id INT4 default '0',";
				$postgre_sql .= "  group_id INT4 default '0',";
				$postgre_sql .= "  feature_name VARCHAR(50),";
				$postgre_sql .= "  feature_value TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (feature_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "features_default (";
				$access_sql .= "  [feature_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [item_type_id] INTEGER,";
				$access_sql .= "  [group_id] INTEGER,";
				$access_sql .= "  [feature_name] VARCHAR(50),";
				$access_sql .= "  [feature_value] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (feature_id));";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "features_default_group_id ON " . $table_prefix . "features_default (group_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "features_default_item_type_id ON " . $table_prefix . "features_default (item_type_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "features_groups (";
				$mysql_sql  .= "  `group_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `group_order` INT(11) NOT NULL default '1',";
				$mysql_sql  .= "  `group_name` VARCHAR(255)";
				$mysql_sql  .= "  ,PRIMARY KEY (group_id))";

				$postgre_sql  = "CREATE TABLE " . $table_prefix . "features_groups (";
				$postgre_sql .= "  group_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "features_groups'),";
				$postgre_sql .= "  group_order INT4 NOT NULL default '1',";
				$postgre_sql .= "  group_name VARCHAR(255)";
				$postgre_sql .= "  ,PRIMARY KEY (group_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "features_groups (";
				$access_sql .= "  [group_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [group_order] INTEGER,";
				$access_sql .= "  [group_name] VARCHAR(255)";
				$access_sql .= "  ,PRIMARY KEY (group_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "INSERT INTO " . $table_prefix . "features_groups (group_id,group_order,group_name) VALUES (1, 1, 'General' )";
				$sqls[] = "INSERT INTO " . $table_prefix . "features_groups (group_id,group_order,group_name) VALUES (2, 2, 'Sizes' )";
				$sqls[] = "INSERT INTO " . $table_prefix . "features_groups (group_id,group_order,group_name) VALUES (3, 3, 'Accessories' )";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN `is_compared` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN is_compared INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN [is_compared] INTEGER " 
				);
				$sqls[] = $sql_types[$db_type];
			}

			if (comp_vers("2.2.2", $current_db_version) == 1) {

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "items_accessories (";
				$mysql_sql  .= "  `item_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `accessory_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `accessory_order` INT(11) NOT NULL default '1'";
				$mysql_sql  .= "  ,PRIMARY KEY (item_id,accessory_id))";

				$postgre_sql  = "CREATE TABLE " . $table_prefix . "items_accessories (";
				$postgre_sql .= "  item_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  accessory_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  accessory_order INT4 NOT NULL default '1'";
				$postgre_sql .= "  ,PRIMARY KEY (item_id,accessory_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "items_accessories (";
				$access_sql .= "  [item_id] INTEGER NOT NULL,";
				$access_sql .= "  [accessory_id] INTEGER NOT NULL,";
				$access_sql .= "  [accessory_order] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (item_id,accessory_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "items_images (";
				$mysql_sql  .= "  `image_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `item_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `image_small` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `small_width` INT(11),";
				$mysql_sql  .= "  `small_height` INT(11),";
				$mysql_sql  .= "  `image_large` VARCHAR(255),";
				$mysql_sql  .= "  `image_title` VARCHAR(255),";
				$mysql_sql  .= "  `image_description` TEXT";
				$mysql_sql  .= "  ,KEY item_id (item_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (image_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "items_images START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "items_images (";
				$postgre_sql .= "  image_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "items_images'),";
				$postgre_sql .= "  item_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  image_small VARCHAR(255) NOT NULL,";
				$postgre_sql .= "  small_width INT4,";
				$postgre_sql .= "  small_height INT4,";
				$postgre_sql .= "  image_large VARCHAR(255),";
				$postgre_sql .= "  image_title VARCHAR(255),";
				$postgre_sql .= "  image_description TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (image_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "items_images (";
				$access_sql .= "  [image_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [item_id] INTEGER,";
				$access_sql .= "  [image_small] VARCHAR(255),";
				$access_sql .= "  [small_width] INTEGER,";
				$access_sql .= "  [small_height] INTEGER,";
				$access_sql .= "  [image_large] VARCHAR(255),";
				$access_sql .= "  [image_title] VARCHAR(255),";
				$access_sql .= "  [image_description] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (image_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "items_images_item_id ON " . $table_prefix . "items_images (item_id)";
				}

			}

			if (comp_vers("2.2.3", $current_db_version) == 1) {

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "newsletters (";
				$mysql_sql  .= "  `newsletter_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `newsletter_date` DATETIME NOT NULL,";
				$mysql_sql  .= "  `newsletter_subject` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `newsletter_body` TEXT,";
				$mysql_sql  .= "  `mail_type` INT(11) default 0,";
				$mysql_sql  .= "  `mail_from` VARCHAR(128),";
				$mysql_sql  .= "  `mail_reply_to` VARCHAR(128),";
				$mysql_sql  .= "  `mail_return_path` VARCHAR(128),";
				$mysql_sql  .= "  `mailing_start` DATETIME,";
				$mysql_sql  .= "  `mailing_end` DATETIME,";
				$mysql_sql  .= "  `emails_left` INT(11) default '0',";
				$mysql_sql  .= "  `emails_sent` INT(11) default '0',";
				$mysql_sql  .= "  `is_active` INT(11) default '0',";
				$mysql_sql  .= "  `is_sent` INT(11) default '0',";
				$mysql_sql  .= "  `is_prepared` INT(11) default '0',";
				$mysql_sql  .= "  `users_recipients` TEXT,";
				$mysql_sql  .= "  `admins_recipients` TEXT,";
				$mysql_sql  .= "  `subscribed_recipients` TEXT,";
				$mysql_sql  .= "  `added_by` INT(11) default '0',";
				$mysql_sql  .= "  `added_date` DATETIME,";
				$mysql_sql  .= "  `edited_by` INT(11) default '0',";
				$mysql_sql  .= "  `edited_date` DATETIME";
				$mysql_sql  .= "  ,PRIMARY KEY (newsletter_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "newsletters START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "newsletters (";
				$postgre_sql .= "  newsletter_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "newsletters'),";
				$postgre_sql .= "  newsletter_date TIMESTAMP NOT NULL,";
				$postgre_sql .= "  newsletter_subject VARCHAR(255) NOT NULL,";
				$postgre_sql .= "  newsletter_body TEXT,";
				$postgre_sql .= "  mail_type INT4 default '0',";
				$postgre_sql .= "  mail_from VARCHAR(128),";
				$postgre_sql .= "  mail_reply_to VARCHAR(128),";
				$postgre_sql .= "  mail_return_path VARCHAR(128),";
				$postgre_sql .= "  mailing_start TIMESTAMP,";
				$postgre_sql .= "  mailing_end TIMESTAMP,";
				$postgre_sql .= "  emails_left INT4 default '0',";
				$postgre_sql .= "  emails_sent INT4 default '0',";
				$postgre_sql .= "  is_active INT4 default '0',";
				$postgre_sql .= "  is_sent INT4 default '0',";
				$postgre_sql .= "  is_prepared INT4 default '0',";
				$postgre_sql .= "  users_recipients TEXT,";
				$postgre_sql .= "  admins_recipients TEXT,";
				$postgre_sql .= "  subscribed_recipients TEXT,";
				$postgre_sql .= "  added_by INT4 default '0',";
				$postgre_sql .= "  added_date TIMESTAMP,";
				$postgre_sql .= "  edited_by INT4 default '0',";
				$postgre_sql .= "  edited_date TIMESTAMP";
				$postgre_sql .= "  ,PRIMARY KEY (newsletter_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "newsletters (";
				$access_sql .= "  [newsletter_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [newsletter_date] DATETIME,";
				$access_sql .= "  [newsletter_subject] VARCHAR(255),";
				$access_sql .= "  [newsletter_body] LONGTEXT,";
				$access_sql .= "  [mail_type] INTEGER,";
				$access_sql .= "  [mail_from] VARCHAR(128),";
				$access_sql .= "  [mail_reply_to] VARCHAR(128),";
				$access_sql .= "  [mail_return_path] VARCHAR(128),";
				$access_sql .= "  [mailing_start] DATETIME,";
				$access_sql .= "  [mailing_end] DATETIME,";
				$access_sql .= "  [emails_left] INTEGER,";
				$access_sql .= "  [emails_sent] INTEGER,";
				$access_sql .= "  [is_active] INTEGER,";
				$access_sql .= "  [is_sent] INTEGER,";
				$access_sql .= "  [is_prepared] INTEGER,";
				$access_sql .= "  [users_recipients] LONGTEXT,";
				$access_sql .= "  [admins_recipients] LONGTEXT,";
				$access_sql .= "  [subscribed_recipients] LONGTEXT,";
				$access_sql .= "  [added_by] INTEGER,";
				$access_sql .= "  [added_date] DATETIME,";
				$access_sql .= "  [edited_by] INTEGER,";
				$access_sql .= "  [edited_date] DATETIME";
				$access_sql .= "  ,PRIMARY KEY (newsletter_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "newsletters_emails (";
				$mysql_sql  .= "  `email_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `newsletter_id` INT(11) default '0',";
				$mysql_sql  .= "  `user_email` VARCHAR(128) NOT NULL,";
				$mysql_sql  .= "  `user_name` VARCHAR(128)";
				$mysql_sql  .= "  ,KEY newsletter_id (newsletter_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (email_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "newsletters_emails START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "newsletters_emails (";
				$postgre_sql .= "  email_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "newsletters_emails'),";
				$postgre_sql .= "  newsletter_id INT4 default '0',";
				$postgre_sql .= "  user_email VARCHAR(128) NOT NULL,";
				$postgre_sql .= "  user_name VARCHAR(128)";
				$postgre_sql .= "  ,PRIMARY KEY (email_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "newsletters_emails (";
				$access_sql .= "  [email_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [newsletter_id] INTEGER,";
				$access_sql .= "  [user_email] VARCHAR(128),";
				$access_sql .= "  [user_name] VARCHAR(128)";
				$access_sql .= "  ,PRIMARY KEY (email_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "newsletters_emails_newsletter_id ON " . $table_prefix . "newsletters_emails (newsletter_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "newsletters_users (";
				$mysql_sql  .= "  `email_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `email` VARCHAR(50),";
				$mysql_sql  .= "  `date_added` DATETIME";
				$mysql_sql  .= "  ,KEY email (email)";
				$mysql_sql  .= "  ,PRIMARY KEY (email_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "newsletters_users START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "newsletters_users (";
				$postgre_sql .= "  email_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "newsletters_users'),";
				$postgre_sql .= "  email VARCHAR(50),";
				$postgre_sql .= "  date_added TIMESTAMP";
				$postgre_sql .= "  ,PRIMARY KEY (email_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "newsletters_users (";
				$access_sql .= "  [email_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [email] VARCHAR(50),";
				$access_sql .= "  [date_added] DATETIME";
				$access_sql .= "  ,PRIMARY KEY (email_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "newsletters_users_email ON " . $table_prefix . "newsletters_users (email)";
				}

			}

			if (comp_vers("2.2.4", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `advanced_php_lib` VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN advanced_php_lib VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [advanced_php_lib] VARCHAR(255) " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `is_active` INT(11) NOT NULL default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN is_active INT4 NOT NULL default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [is_active] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				// update products list layouts
				$payment_id = get_setting_value($settings, "payment_id");
				$sqls[] = " UPDATE " . $table_prefix . "payment_systems SET is_active=1 WHERE payment_id=" . $db->tosql($payment_id, INTEGER);

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `payment_id` INT(11) NOT NULL default '0' AFTER user_id",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN payment_id INT4 NOT NULL default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [payment_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

			}

			if (comp_vers("2.2.5", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN remote_address VARCHAR(32) AFTER payment_id ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN remote_address VARCHAR(32) ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN remote_address VARCHAR(32) " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN shipping_tracking_id VARCHAR(32) AFTER shipping_cost",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN shipping_tracking_id VARCHAR(32) ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN shipping_tracking_id VARCHAR(32) " 
				);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "orders_notes (";
				$mysql_sql  .= "  `note_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `order_id` INT(11) default '0',";
				$mysql_sql  .= "  `note_title` VARCHAR(255),";
				$mysql_sql  .= "  `note_details` TEXT,";
				$mysql_sql  .= "  `show_for_user` INT(11) default '0',";
				$mysql_sql  .= "  `date_added` DATETIME,";
				$mysql_sql  .= "  `date_updated` DATETIME";
				$mysql_sql  .= "  ,KEY order_id (order_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (note_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "orders_notes START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "orders_notes (";
				$postgre_sql .= "  note_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "orders_notes'),";
				$postgre_sql .= "  order_id INT4 default '0',";
				$postgre_sql .= "  note_title VARCHAR(255),";
				$postgre_sql .= "  note_details TEXT,";
				$postgre_sql .= "  show_for_user INT4 default '0',";
				$postgre_sql .= "  date_added TIMESTAMP,";
				$postgre_sql .= "  date_updated TIMESTAMP";
				$postgre_sql .= "  ,PRIMARY KEY (note_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "orders_notes (";
				$access_sql .= "  [note_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [order_id] INTEGER,";
				$access_sql .= "  [note_title] VARCHAR(255),";
				$access_sql .= "  [note_details] LONGTEXT,";
				$access_sql .= "  [show_for_user] INTEGER,";
				$access_sql .= "  [date_added] DATETIME,";
				$access_sql .= "  [date_updated] DATETIME";
				$access_sql .= "  ,PRIMARY KEY (note_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_notes_order_id ON " . $table_prefix . "orders_notes (order_id)";
				}

			}

			if (comp_vers("2.2.6", $current_db_version) == 1) {

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "user_types (";
				$mysql_sql  .= "  `type_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `type_name` VARCHAR(128),";
				$mysql_sql  .= "  `is_default` INT(11) default '0'";
				$mysql_sql  .= "  ,PRIMARY KEY (type_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "user_types START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "user_types (";
				$postgre_sql .= "  type_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "user_types'),";
				$postgre_sql .= "  type_name VARCHAR(128),";
				$postgre_sql .= "  is_default INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (type_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "user_types (";
				$access_sql .= "  [type_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [type_name] VARCHAR(128),";
				$access_sql .= "  [is_default] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (type_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "user_types_settings (";
				$mysql_sql  .= "  `type_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `setting_name` VARCHAR(64) NOT NULL,";
				$mysql_sql  .= "  `setting_value` VARCHAR(50)";
				$mysql_sql  .= "  ,PRIMARY KEY (type_id,setting_name))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "user_types_settings START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "user_types_settings (";
				$postgre_sql .= "  type_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  setting_name VARCHAR(64) NOT NULL,";
				$postgre_sql .= "  setting_value VARCHAR(50)";
				$postgre_sql .= "  ,PRIMARY KEY (type_id,setting_name))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "user_types_settings (";
				$access_sql .= "  [type_id] INTEGER NOT NULL,";
				$access_sql .= "  [setting_name] VARCHAR(64) NOT NULL,";
				$access_sql .= "  [setting_value] VARCHAR(50)";
				$access_sql .= "  ,PRIMARY KEY (type_id,setting_name))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "INSERT INTO " . $table_prefix . "user_types (type_id,type_name,is_default) VALUES (1, 'Customer', 1)";
				$sqls[] = "INSERT INTO " . $table_prefix . "user_types_settings (type_id,setting_name,setting_value) VALUES (1, 'new_profile', 1)";
				$sqls[] = "INSERT INTO " . $table_prefix . "user_types_settings (type_id,setting_name,setting_value) VALUES (1, 'edit_profile', 1)";
				$sqls[] = "INSERT INTO " . $table_prefix . "user_types_settings (type_id,setting_name,setting_value) VALUES (1, 'approve_profile', 1)";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN `company_id` INT(11) default '0' AFTER last_name ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN company_id INT4 default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN [company_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN `delivery_company_id` INT(11) default '0' AFTER last_name ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN delivery_company_id INT4 default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN [delivery_company_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `company_id` INT(11) default '0' AFTER last_name ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN company_id INT4 default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [company_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `delivery_company_id` INT(11) default '0' AFTER last_name ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN delivery_company_id INT4 default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [delivery_company_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN `user_type_id` INT(11) default '0' AFTER user_id ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN user_type_id INT4 default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN [user_type_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN `is_approved` INT(11) default '0' AFTER user_type_id ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN is_approved INT4 default '0'",
					"access" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN [is_approved] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "UPDATE " . $table_prefix . "users SET user_type_id=1,is_approved=1 ";
				$sqls[] = "UPDATE " . $table_prefix . "global_settings SET setting_type='user_profile_1' WHERE setting_type='user_profile'";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `shipping_taxable` INT(11) default '1' AFTER shipping_cost ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN shipping_taxable INT4 default '1'",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [shipping_taxable] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = "UPDATE " . $table_prefix . "orders SET shipping_taxable=1 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN `is_taxable` INT(11) default '1' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN is_taxable INT4 default '1'",
					"access" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN [is_taxable] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = "UPDATE " . $table_prefix . "shipping_types SET is_taxable=1 ";

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "companies (";
				$mysql_sql  .= "  `company_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `company_name` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `image_small` VARCHAR(50),";
				$mysql_sql  .= "  `image_large` VARCHAR(50),";
				$mysql_sql  .= "  `address_info` TEXT,";
				$mysql_sql  .= "  `phone_number` VARCHAR(32),";
				$mysql_sql  .= "  `fax_number` VARCHAR(32),";
				$mysql_sql  .= "  `site_url` VARCHAR(128),";
				$mysql_sql  .= "  `contact_email` VARCHAR(128),";
				$mysql_sql  .= "  `short_description` TEXT,";
				$mysql_sql  .= "  `full_description` TEXT";
				$mysql_sql  .= "  ,PRIMARY KEY (company_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "companies START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "companies (";
				$postgre_sql .= "  company_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "companies'),";
				$postgre_sql .= "  company_name VARCHAR(255) NOT NULL,";
				$postgre_sql .= "  image_small VARCHAR(50),";
				$postgre_sql .= "  image_large VARCHAR(50),";
				$postgre_sql .= "  address_info TEXT,";
				$postgre_sql .= "  phone_number VARCHAR(32),";
				$postgre_sql .= "  fax_number VARCHAR(32),";
				$postgre_sql .= "  site_url VARCHAR(128),";
				$postgre_sql .= "  contact_email VARCHAR(128),";
				$postgre_sql .= "  short_description TEXT,";
				$postgre_sql .= "  full_description TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (company_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "companies (";
				$access_sql .= "  [company_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [company_name] VARCHAR(255),";
				$access_sql .= "  [image_small] VARCHAR(50),";
				$access_sql .= "  [image_large] VARCHAR(50),";
				$access_sql .= "  [address_info] LONGTEXT,";
				$access_sql .= "  [phone_number] VARCHAR(32),";
				$access_sql .= "  [fax_number] VARCHAR(32),";
				$access_sql .= "  [site_url] VARCHAR(128),";
				$access_sql .= "  [contact_email] VARCHAR(128),";
				$access_sql .= "  [short_description] LONGTEXT,";
				$access_sql .= "  [full_description] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (company_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_assigned (";
				$mysql_sql  .= "  `item_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `category_id` INT(11) NOT NULL default '0'";
				$mysql_sql  .= "  ,PRIMARY KEY (item_id,category_id))";

				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_assigned (";
				$postgre_sql .= "  item_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  category_id INT4 NOT NULL default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (item_id,category_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_assigned (";
				$access_sql .= "  [item_id] INTEGER NOT NULL,";
				$access_sql .= "  [category_id] INTEGER NOT NULL";
				$access_sql .= "  ,PRIMARY KEY (item_id,category_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_categories (";
				$mysql_sql  .= "  `category_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `language_code` VARCHAR(2),";
				$mysql_sql  .= "  `parent_category_id` INT(11) default '0',";
				$mysql_sql  .= "  `alias_category_id` INT(11) default '0',";
				$mysql_sql  .= "  `category_path` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `category_name` VARCHAR(255),";
				$mysql_sql  .= "  `category_order` INT(11) default '0',";
				$mysql_sql  .= "  `allowed_view` INT(11) default '0',";
				$mysql_sql  .= "  `allowed_post` INT(11) default '0',";
				$mysql_sql  .= "  `short_description` TEXT,";
				$mysql_sql  .= "  `full_description` TEXT,";
				$mysql_sql  .= "  `image_small` VARCHAR(255),";
				$mysql_sql  .= "  `image_large` VARCHAR(255),";
				$mysql_sql  .= "  `total_ads` INT(11) default '0',";
				$mysql_sql  .= "  `total_subcategories` INT(11) default '0'";
				$mysql_sql  .= "  ,KEY category_path (category_path)";
				$mysql_sql  .= "  ,KEY parent_category_id (parent_category_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (category_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_categories START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_categories (";
				$postgre_sql .= "  category_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_categories'),";
				$postgre_sql .= "  language_code VARCHAR(2),";
				$postgre_sql .= "  parent_category_id INT4 default '0',";
				$postgre_sql .= "  alias_category_id INT4 default '0',";
				$postgre_sql .= "  category_path VARCHAR(255) NOT NULL,";
				$postgre_sql .= "  category_name VARCHAR(255),";
				$postgre_sql .= "  category_order INT4 default '0',";
				$postgre_sql .= "  allowed_view INT4 default '0',";
				$postgre_sql .= "  allowed_post INT4 default '0',";
				$postgre_sql .= "  short_description TEXT,";
				$postgre_sql .= "  full_description TEXT,";
				$postgre_sql .= "  image_small VARCHAR(255),";
				$postgre_sql .= "  image_large VARCHAR(255),";
				$postgre_sql .= "  total_ads INT4 default '0',";
				$postgre_sql .= "  total_subcategories INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (category_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_categories (";
				$access_sql .= "  [category_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [language_code] VARCHAR(2),";
				$access_sql .= "  [parent_category_id] INTEGER,";
				$access_sql .= "  [alias_category_id] INTEGER,";
				$access_sql .= "  [category_path] VARCHAR(255),";
				$access_sql .= "  [category_name] VARCHAR(255),";
				$access_sql .= "  [category_order] INTEGER,";
				$access_sql .= "  [allowed_view] INTEGER,";
				$access_sql .= "  [allowed_post] INTEGER,";
				$access_sql .= "  [short_description] LONGTEXT,";
				$access_sql .= "  [full_description] LONGTEXT,";
				$access_sql .= "  [image_small] VARCHAR(255),";
				$access_sql .= "  [image_large] VARCHAR(255),";
				$access_sql .= "  [total_ads] INTEGER,";
				$access_sql .= "  [total_subcategories] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (category_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_categories_category_path ON " . $table_prefix . "ads_categories (category_path)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_categories_parent_category_id ON " . $table_prefix . "ads_categories (parent_category_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_features (";
				$mysql_sql  .= "  `feature_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `item_id` INT(11) default '0',";
				$mysql_sql  .= "  `group_id` INT(11) default '0',";
				$mysql_sql  .= "  `feature_name` VARCHAR(255),";
				$mysql_sql  .= "  `feature_value` VARCHAR(255)";
				$mysql_sql  .= "  ,KEY group_id (group_id)";
				$mysql_sql  .= "  ,KEY item_id (item_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (feature_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_features START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_features (";
				$postgre_sql .= "  feature_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_features'),";
				$postgre_sql .= "  item_id INT4 default '0',";
				$postgre_sql .= "  group_id INT4 default '0',";
				$postgre_sql .= "  feature_name VARCHAR(255),";
				$postgre_sql .= "  feature_value VARCHAR(255)";
				$postgre_sql .= "  ,PRIMARY KEY (feature_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_features (";
				$access_sql .= "  [feature_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [item_id] INTEGER,";
				$access_sql .= "  [group_id] INTEGER,";
				$access_sql .= "  [feature_name] VARCHAR(255),";
				$access_sql .= "  [feature_value] VARCHAR(255)";
				$access_sql .= "  ,PRIMARY KEY (feature_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_features_group_id ON " . $table_prefix . "ads_features (group_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_features_item_id ON " . $table_prefix . "ads_features (item_id)";
				}


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_features_default (";
				$mysql_sql  .= "  `feature_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `type_id` INT(11) default '0',";
				$mysql_sql  .= "  `group_id` INT(11) default '0',";
				$mysql_sql  .= "  `feature_name` VARCHAR(255),";
				$mysql_sql  .= "  `feature_value` VARCHAR(255)";
				$mysql_sql  .= "  ,KEY group_id (group_id)";
				$mysql_sql  .= "  ,KEY type_id (type_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (feature_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_features_default START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_features_default (";
				$postgre_sql .= "  feature_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_features_default'),";
				$postgre_sql .= "  type_id INT4 default '0',";
				$postgre_sql .= "  group_id INT4 default '0',";
				$postgre_sql .= "  feature_name VARCHAR(50),";
				$postgre_sql .= "  feature_value TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (feature_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_features_default (";
				$access_sql .= "  [feature_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [type_id] INTEGER,";
				$access_sql .= "  [group_id] INTEGER,";
				$access_sql .= "  [feature_name] VARCHAR(50),";
				$access_sql .= "  [feature_value] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (feature_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if ($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_features_default_group_id ON " . $table_prefix . "ads_features_default (group_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_features_default_item_type_id ON " . $table_prefix . "ads_features_default (type_id)";
				}


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_features_groups (";
				$mysql_sql  .= "  `group_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `group_order` INT(11) NOT NULL default '1',";
				$mysql_sql  .= "  `group_name` VARCHAR(255)";
				$mysql_sql  .= "  ,PRIMARY KEY (group_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_features_groups START 4";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_features_groups (";
				$postgre_sql .= "  group_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_features_groups'),";
				$postgre_sql .= "  group_order INT4 NOT NULL default '1',";
				$postgre_sql .= "  group_name VARCHAR(255)";
				$postgre_sql .= "  ,PRIMARY KEY (group_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_features_groups (";
				$access_sql .= "  [group_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [group_order] INTEGER,";
				$access_sql .= "  [group_name] VARCHAR(255)";
				$access_sql .= "  ,PRIMARY KEY (group_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "INSERT INTO " . $table_prefix . "ads_features_groups (group_id,group_order,group_name) VALUES (1 , 1 , 'General' )";
				$sqls[] = "INSERT INTO " . $table_prefix . "ads_features_groups (group_id,group_order,group_name) VALUES (2 , 2 , 'Sizes' )";
				$sqls[] = "INSERT INTO " . $table_prefix . "ads_features_groups (group_id,group_order,group_name) VALUES (3 , 3 , 'Accessories' )";

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_images (";
				$mysql_sql  .= "  `image_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `item_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `image_small` VARCHAR(255),";
				$mysql_sql  .= "  `small_width` INT(11),";
				$mysql_sql  .= "  `small_height` INT(11),";
				$mysql_sql  .= "  `image_large` VARCHAR(255),";
				$mysql_sql  .= "  `image_title` VARCHAR(255),";
				$mysql_sql  .= "  `image_description` TEXT";
				$mysql_sql  .= "  ,KEY item_id (item_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (image_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_images START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_images (";
				$postgre_sql .= "  image_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_images'),";
				$postgre_sql .= "  item_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  image_small VARCHAR(255),";
				$postgre_sql .= "  small_width INT4,";
				$postgre_sql .= "  small_height INT4,";
				$postgre_sql .= "  image_large VARCHAR(255),";
				$postgre_sql .= "  image_title VARCHAR(255),";
				$postgre_sql .= "  image_description TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (image_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_images (";
				$access_sql .= "  [image_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [item_id] INTEGER,";
				$access_sql .= "  [image_small] VARCHAR(255),";
				$access_sql .= "  [small_width] INTEGER,";
				$access_sql .= "  [small_height] INTEGER,";
				$access_sql .= "  [image_large] VARCHAR(255),";
				$access_sql .= "  [image_title] VARCHAR(255),";
				$access_sql .= "  [image_description] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (image_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_images_item_id ON " . $table_prefix . "ads_images (item_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_items (";
				$mysql_sql  .= "  `item_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `type_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `language_code` VARCHAR(2),";
				$mysql_sql  .= "  `item_title` VARCHAR(50) NOT NULL,";
				$mysql_sql  .= "  `item_order` INT(11) default '0',";
				$mysql_sql  .= "  `user_id` INT(11) default '0',";
				$mysql_sql  .= "  `admin_id` INT(11) default '0',";
				$mysql_sql  .= "  `date_start` DATETIME,";
				$mysql_sql  .= "  `date_end` DATETIME,";
				$mysql_sql  .= "  `date_added` DATETIME,";
				$mysql_sql  .= "  `date_updated` DATETIME,";
				$mysql_sql  .= "  `image_small` VARCHAR(255),";
				$mysql_sql  .= "  `image_large` VARCHAR(255),";
				$mysql_sql  .= "  `is_hot` INT(11) default '0',";
				$mysql_sql  .= "  `hot_description` TEXT,";
				$mysql_sql  .= "  `short_description` TEXT,";
				$mysql_sql  .= "  `full_description` TEXT,";
				$mysql_sql  .= "  `price` FLOAT(10,2) default '0',";
				$mysql_sql  .= "  `quantity` INT(11) default '0',";
				$mysql_sql  .= "  `availability` VARCHAR(255),";
				$mysql_sql  .= "  `location_info` TEXT,";
				$mysql_sql  .= "  `location_city` VARCHAR(128),";
				$mysql_sql  .= "  `location_state` VARCHAR(8),";
				$mysql_sql  .= "  `location_country` VARCHAR(4),";
				$mysql_sql  .= "  `is_approved` INT(11) default '0',";
				$mysql_sql  .= "  `is_compared` INT(11) default '0'";
				$mysql_sql  .= "  ,KEY item_title (item_title)";
				$mysql_sql  .= "  ,PRIMARY KEY (item_id)";
				$mysql_sql  .= "  ,KEY type_id (type_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_items START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_items (";
				$postgre_sql .= "  item_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_items'),";
				$postgre_sql .= "  type_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  language_code VARCHAR(2),";
				$postgre_sql .= "  item_title VARCHAR(50) NOT NULL,";
				$postgre_sql .= "  item_order INT4 default '0',";
				$postgre_sql .= "  user_id INT4 default '0',";
				$postgre_sql .= "  admin_id INT4 default '0',";
				$postgre_sql .= "  date_start TIMESTAMP,";
				$postgre_sql .= "  date_end TIMESTAMP,";
				$postgre_sql .= "  date_added TIMESTAMP,";
				$postgre_sql .= "  date_updated TIMESTAMP,";
				$postgre_sql .= "  image_small VARCHAR(255),";
				$postgre_sql .= "  image_large VARCHAR(255),";
				$postgre_sql .= "  is_hot INT4 default '0',";
				$postgre_sql .= "  hot_description TEXT,";
				$postgre_sql .= "  short_description TEXT,";
				$postgre_sql .= "  full_description TEXT,";
				$postgre_sql .= "  price FLOAT4 default '0',";
				$postgre_sql .= "  quantity INT4 default '0',";
				$postgre_sql .= "  availability VARCHAR(255),";
				$postgre_sql .= "  location_info TEXT,";
				$postgre_sql .= "  location_city VARCHAR(128),";
				$postgre_sql .= "  location_state VARCHAR(8),";
				$postgre_sql .= "  location_country VARCHAR(4),";
				$postgre_sql .= "  is_approved INT4 default '0',";
				$postgre_sql .= "  is_compared INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (item_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_items (";
				$access_sql .= "  [item_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [type_id] INTEGER,";
				$access_sql .= "  [language_code] VARCHAR(2),";
				$access_sql .= "  [item_title] VARCHAR(50),";
				$access_sql .= "  [item_order] INTEGER,";
				$access_sql .= "  [user_id] INTEGER,";
				$access_sql .= "  [admin_id] INTEGER,";
				$access_sql .= "  [date_start] DATETIME,";
				$access_sql .= "  [date_end] DATETIME,";
				$access_sql .= "  [date_added] DATETIME,";
				$access_sql .= "  [date_updated] DATETIME,";
				$access_sql .= "  [image_small] VARCHAR(255),";
				$access_sql .= "  [image_large] VARCHAR(255),";
				$access_sql .= "  [is_hot] INTEGER,";
				$access_sql .= "  [hot_description] LONGTEXT,";
				$access_sql .= "  [short_description] LONGTEXT,";
				$access_sql .= "  [full_description] LONGTEXT,";
				$access_sql .= "  [price] FLOAT,";
				$access_sql .= "  [quantity] INTEGER,";
				$access_sql .= "  [availability] VARCHAR(255),";
				$access_sql .= "  [location_info] LONGTEXT,";
				$access_sql .= "  [location_city] VARCHAR(128),";
				$access_sql .= "  [location_state] VARCHAR(8),";
				$access_sql .= "  [location_country] VARCHAR(4),";
				$access_sql .= "  [is_approved] INTEGER,";
				$access_sql .= "  [is_compared] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (item_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_items_item_title ON " . $table_prefix . "ads_items (item_title)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_items_type_id ON " . $table_prefix . "ads_items (type_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_properties (";
				$mysql_sql  .= "  `property_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `item_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `property_name` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `property_value` TEXT";
				$mysql_sql  .= "  ,KEY item_id (item_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (property_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_properties START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_properties (";
				$postgre_sql .= "  property_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_properties'),";
				$postgre_sql .= "  item_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  property_name VARCHAR(255) NOT NULL,";
				$postgre_sql .= "  property_value TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (property_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_properties (";
				$access_sql .= "  [property_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [item_id] INTEGER,";
				$access_sql .= "  [property_name] VARCHAR(255),";
				$access_sql .= "  [property_value] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (property_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_properties_item_id ON " . $table_prefix . "ads_properties (item_id)";
				}


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_properties_default (";
				$mysql_sql  .= "  `property_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `type_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `property_name` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `property_value` TEXT";
				$mysql_sql  .= "  ,KEY item_id (type_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (property_id))";
				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_properties START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_properties_default (";
				$postgre_sql .= "  property_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_properties'),";
				$postgre_sql .= "  type_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  property_name VARCHAR(255) NOT NULL,";
				$postgre_sql .= "  property_value TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (property_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_properties_default (";
				$access_sql .= "  [property_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [type_id] INTEGER,";
				$access_sql .= "  [property_name] VARCHAR(255),";
				$access_sql .= "  [property_value] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (property_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "ads_properties_default_item_id ON " . $table_prefix . "ads_properties_default (type_id)";
				}


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "ads_types (";
				$mysql_sql  .= "  `type_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `type_name` VARCHAR(50)";
				$mysql_sql  .= "  ,PRIMARY KEY (type_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "ads_types START 3";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "ads_types (";
				$postgre_sql .= "  type_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "ads_types'),";
				$postgre_sql .= "  type_name VARCHAR(50)";
				$postgre_sql .= "  ,PRIMARY KEY (type_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "ads_types (";
				$access_sql .= "  [type_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [type_name] VARCHAR(50)";
				$access_sql .= "  ,PRIMARY KEY (type_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "INSERT INTO " . $table_prefix . "ads_types (`type_id`,`type_name`) VALUES (1 , 'Product' )";
				$sqls[] = "INSERT INTO " . $table_prefix . "ads_types (`type_id`,`type_name`) VALUES (2 , 'Accessory' )";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN payment_info TEXT AFTER payment_name",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN payment_info TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN payment_info LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN payment_notes TEXT AFTER payment_info",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN payment_notes TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN payment_notes LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$cc_settings = array();
				$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='credit_card_info' ";
				$db->query($sql);
				while ($db->next_record()) {
					$cc_settings[$db->f("setting_name")] = $db->f("setting_value");
				}

				$sql = "SELECT payment_id FROM " . $table_prefix . "payment_systems ";
				$db->query($sql);
				while ($db->next_record()) {
					$payment_id = $db->f("payment_id");
					foreach ($cc_settings as $setting_name => $setting_value) {
						$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type,setting_name,setting_value) VALUES (";
						$sql .= $db->tosql("credit_card_info_" . $payment_id, TEXT) . ",";
						$sql .= $db->tosql($setting_name, TEXT) . ", ";
						$sql .= $db->tosql($setting_value, TEXT) . ") ";
						$sqls[] = $sql;
					}
				}
				$sqls[] = " DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='credit_card_info' ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "tax_rates ADD COLUMN state_code VARCHAR(8) AFTER tax_name ",
					"postgre" => "ALTER TABLE " . $table_prefix . "tax_rates ADD COLUMN state_code VARCHAR(8) ",
					"access"  => "ALTER TABLE " . $table_prefix . "tax_rates ADD COLUMN state_code VARCHAR(8) " 
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN currency_code VARCHAR(4) AFTER coupons_ids ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN currency_code VARCHAR(4) ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN currency_code VARCHAR(4) " 
				);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "orders_events (";
				$mysql_sql  .= "  `event_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `order_id` INT(11) default '0',";
				$mysql_sql  .= "  `admin_id` INT(11) default '0',";
				$mysql_sql  .= "  `event_date` DATETIME,";
				$mysql_sql  .= "  `event_name` VARCHAR(64),";
				$mysql_sql  .= "  `event_description` TEXT";
				$mysql_sql  .= "  ,KEY admin_id (admin_id)";
				$mysql_sql  .= "  ,KEY order_id (order_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (event_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "orders_events START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "orders_events (";
				$postgre_sql .= "  event_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "orders_events'),";
				$postgre_sql .= "  order_id INT4 default '0',";
				$postgre_sql .= "  admin_id INT4 default '0',";
				$postgre_sql .= "  event_date TIMESTAMP,";
				$postgre_sql .= "  event_name VARCHAR(64),";
				$postgre_sql .= "  event_description TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (event_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "orders_events (";
				$access_sql .= "  [event_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [order_id] INTEGER,";
				$access_sql .= "  [admin_id] INTEGER,";
				$access_sql .= "  [event_date] DATETIME,";
				$access_sql .= "  [event_name] VARCHAR(64),";
				$access_sql .= "  [event_description] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (event_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_events_admin_id ON " . $table_prefix . "orders_events (admin_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_events_order_id ON " . $table_prefix . "orders_events (order_id)";
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `last_order_id` INT(11) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN last_order_id INT4 ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [last_order_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `exported_order_id` INT(11) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN exported_order_id INT4 ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [exported_order_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `last_user_id` INT(11) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN last_user_id INT4 ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [last_user_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `exported_user_id` INT(11) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN exported_user_id INT4 ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [exported_user_id] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `download_notify` INT(11) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN download_notify INT4 ",
					"access" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [download_notify] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `mail_notify` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_notify INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [mail_notify] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `mail_from` VARCHAR(64) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_from VARCHAR(64) ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [mail_from] VARCHAR(64) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `mail_cc` VARCHAR(128) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_cc VARCHAR(128) ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [mail_cc] VARCHAR(128) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `mail_bcc` VARCHAR(128) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_bcc VARCHAR(128) ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [mail_bcc] VARCHAR(128) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `mail_reply_to` VARCHAR(64) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_reply_to VARCHAR(64) ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [mail_reply_to] VARCHAR(64) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `mail_return_path` VARCHAR(64) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_return_path VARCHAR(64) ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [mail_return_path] VARCHAR(64) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `mail_type` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_type INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [mail_type] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `mail_subject` VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_subject VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [mail_subject] VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_body TEXT",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_body TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_body LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

			}

			if (comp_vers("2.2.7", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `exported_order_fields` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN exported_order_fields TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [exported_order_fields] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `exported_user_fields` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN exported_user_fields TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [exported_user_fields] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `imported_user_fields` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN imported_user_fields TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [imported_user_fields] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `exported_item_fields` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN exported_item_fields TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [exported_item_fields] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `imported_item_fields` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN imported_item_fields TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [imported_item_fields] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN `last_visit_date` DATETIME ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN last_visit_date TIMESTAMP ",
					"access" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN [last_visit_date] DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN `personal_image` VARCHAR(255) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN personal_image VARCHAR(255) ",
					"access" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN [personal_image] VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN `last_visit_date` DATETIME ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN last_visit_date TIMESTAMP ",
					"access" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN [last_visit_date] DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN `tare_weight` FLOAT(10,4) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN tare_weight FLOAT4 ",
					"access" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN [tare_weight] FLOAT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `property_order` INT(11) default '1' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN property_order INT4 default '1' ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [property_order] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `control_code` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN control_code TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [control_code] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `onchange_code` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN onchange_code TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [onchange_code] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `onclick_code` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN onclick_code TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [onclick_code] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN `manufacturer_code` VARCHAR(64) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN manufacturer_code VARCHAR(64) ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN [manufacturer_code] VARCHAR(64) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN `download_period` INT(11) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN download_period INT4 ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN [download_period] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN `download_path` VARCHAR(255) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN download_path VARCHAR(255) ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN [download_path] VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN `stock_level` INT(11) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN stock_level INT4 ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN [stock_level] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN `hide_out_of_stock` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN hide_out_of_stock INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN [hide_out_of_stock] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN `manufacturer_code` VARCHAR(255) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN manufacturer_code VARCHAR(255) ",
					"access" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN [manufacturer_code] VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " UPDATE " . $table_prefix . "items_properties SET property_order=1 ";
			}

			if (comp_vers("2.2.8", $current_db_version) == 1) {

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "languages (";
				$mysql_sql  .= "  `language_code` VARCHAR(2) NOT NULL,";
				$mysql_sql  .= "  `language_name` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `show_for_user` INT(11) default '0',";
				$mysql_sql  .= "  `language_image` VARCHAR(128),";
				$mysql_sql  .= "  `currency_code` VARCHAR(4)";
				$mysql_sql  .= "  ,PRIMARY KEY (language_code))";

				$postgre_sql  = "CREATE TABLE " . $table_prefix . "languages (";
				$postgre_sql .= "  language_code VARCHAR(2) NOT NULL,";
				$postgre_sql .= "  language_name VARCHAR(255) NOT NULL,";
				$postgre_sql .= "  show_for_user INT4 default '0',";
				$postgre_sql .= "  language_image VARCHAR(128),";
				$postgre_sql .= "  currency_code VARCHAR(4)";
				$postgre_sql .= "  ,PRIMARY KEY (language_code))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "languages (";
				$access_sql .= "  [language_code] VARCHAR(2) NOT NULL,";
				$access_sql .= "  [language_name] VARCHAR(255),";
				$access_sql .= "  [show_for_user] INTEGER,";
				$access_sql .= "  [language_image] VARCHAR(128),";
				$access_sql .= "  [currency_code] VARCHAR(4)";
				$access_sql .= "  ,PRIMARY KEY (language_code))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "INSERT INTO " . $table_prefix . "languages (language_code,language_name,show_for_user,language_image) VALUES ('en', 'English', 1, 'images/flags/gb.gif')";
				$sqls[] = "INSERT INTO " . $table_prefix . "languages (language_code,language_name,show_for_user,language_image) VALUES ('es', 'Spanish', 1, 'images/flags/es.gif')";
				$sqls[] = "INSERT INTO " . $table_prefix . "languages (language_code,language_name,show_for_user,language_image) VALUES ('nl', 'Dutch', 1, 'images/flags/nl.gif')";
				$sqls[] = "INSERT INTO " . $table_prefix . "languages (language_code,language_name,show_for_user,language_image) VALUES ('el', 'Greek', 1, 'images/flags/gr.gif')";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `transaction_id` VARCHAR(32) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN transaction_id VARCHAR(32) ",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [transaction_id] VARCHAR(32) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `order_error` VARCHAR(255) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN order_error VARCHAR(255) ",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [order_error] VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "countries ADD COLUMN `currency_code` VARCHAR(4) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "countries ADD COLUMN currency_code VARCHAR(4) ",
					"access" => "ALTER TABLE " . $table_prefix . "countries ADD COLUMN [currency_code] VARCHAR(4) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `use_on_list` INT(11) default '1' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN use_on_list INT4 default '1' ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [use_on_list] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `use_on_details` INT(11) default '1' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN use_on_details INT4 default '1' ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [use_on_details] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "items_properties SET use_on_list=1, use_on_details=1 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "layouts ADD COLUMN `style_name` VARCHAR(64) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "layouts ADD COLUMN style_name VARCHAR(64) ",
					"access" => "ALTER TABLE " . $table_prefix . "layouts ADD COLUMN [style_name] VARCHAR(64) "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "layouts SET style_name='default' WHERE layout_name LIKE 'Default%'";
				$sqls[] = " UPDATE " . $table_prefix . "layouts SET style_name='curved' WHERE layout_name LIKE 'Curved%'";
				$sqls[] = " UPDATE " . $table_prefix . "layouts SET style_name='silver' WHERE layout_name LIKE 'Silver%'";

				$final_settings = array();
				$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_confirmation' AND setting_name<>'intro_text'";
				$db->query($sql);
				while ($db->next_record()) {
					$final_settings[$db->f("setting_name")] = $db->f("setting_value");
				}
				$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_final' AND setting_name='final_message'";
				$db->query($sql);
				if ($db->next_record()) {
					$final_settings["success_message"] = $db->f("setting_value");
				}
				$final_settings["failure_message"] = "<div>An error: \"{error_desc}\" occurred while processing your order. We are sorry for any inconvenient caused.</div>";

				$sql = "SELECT payment_id FROM " . $table_prefix . "payment_systems ";
				$db->query($sql);
				while ($db->next_record()) {
					$payment_id = $db->f("payment_id");
					foreach ($final_settings as $setting_name => $setting_value) {
						$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type,setting_name,setting_value) VALUES (";
						$sql .= $db->tosql("order_final_" . $payment_id, TEXT) . ",";
						$sql .= $db->tosql($setting_name, TEXT) . ", ";
						$sql .= $db->tosql($setting_value, TEXT) . ") ";
						$sqls[] = $sql;
					}
				}
				$sqls[] = " DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='order_confirmation' AND setting_name<>'intro_text' ";
				$sqls[] = " DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='order_final' AND setting_name='final_message' ";
				$sqls[] = " UPDATE " . $table_prefix . "global_settings SET setting_type='download_info' WHERE setting_type='order_final' ";
			}

			if (comp_vers("2.2.9", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `error_message` VARCHAR(255) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN error_message VARCHAR(255) ",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [error_message] VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `pending_message` VARCHAR(255) ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN pending_message VARCHAR(255) ",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [pending_message] VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " UPDATE " . $table_prefix . "orders SET error_message=order_error ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders DROP COLUMN `order_error` ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders DROP COLUMN COLUMN order_error ",
					"access" => "ALTER TABLE " . $table_prefix . "orders DROP COLUMN [order_error] "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `is_exported` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN is_exported INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [is_exported] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `currency_rate` FLOAT(10,8) default '1' AFTER currency_code ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN currency_rate FLOAT4 default '1' AFTER currency_code ",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [currency_rate] FLOAT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql  = "CREATE TABLE " . $table_prefix . "black_ips (";
				$sql .= "  ip_address VARCHAR(32) NOT NULL,";
				$sql .= "  adress_action VARCHAR(32),";
				$sql .= "  adress_notes VARCHAR(255)";
				$sql .= "  ,PRIMARY KEY (ip_address))";
				$sqls[] = $sql;

			}

			if (comp_vers("2.2.10", $current_db_version) == 1) {

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "orders_items_serials (";
				$mysql_sql  .= "  `serial_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `order_id` INT(11) default '0',";
				$mysql_sql  .= "  `user_id` INT(11) default '0',";
				$mysql_sql  .= "  `order_item_id` INT(11) default '0',";
				$mysql_sql  .= "  `item_id` INT(11) default '0',";
				$mysql_sql  .= "  `serial_number` VARCHAR(128),";
				$mysql_sql  .= "  `activated` INT(11) default '0',";
				$mysql_sql  .= "  `activations_number` INT(11) default '0',";
				$mysql_sql  .= "  `serial_added` DATETIME";
				$mysql_sql  .= "  ,KEY item_id (item_id)";
				$mysql_sql  .= "  ,KEY order_id (order_id)";
				$mysql_sql  .= "  ,KEY order_item_id (order_item_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (serial_id)";
				$mysql_sql  .= "  ,KEY serial_number (serial_number)";
				$mysql_sql  .= "  ,KEY user_id (user_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "orders_items_serials START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "orders_items_serials (";
				$postgre_sql .= "  serial_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "orders_items_serials'),";
				$postgre_sql .= "  order_id INT4 default '0',";
				$postgre_sql .= "  user_id INT4 default '0',";
				$postgre_sql .= "  order_item_id INT4 default '0',";
				$postgre_sql .= "  item_id INT4 default '0',";
				$postgre_sql .= "  serial_number VARCHAR(128),";
				$postgre_sql .= "  activated INT4 default '0',";
				$postgre_sql .= "  activations_number INT4 default '0',";
				$postgre_sql .= "  serial_added TIMESTAMP";
				$postgre_sql .= "  ,PRIMARY KEY (serial_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "orders_items_serials (";
				$access_sql .= "  [serial_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [order_id] INTEGER,";
				$access_sql .= "  [user_id] INTEGER,";
				$access_sql .= "  [order_item_id] INTEGER,";
				$access_sql .= "  [item_id] INTEGER,";
				$access_sql .= "  [serial_number] VARCHAR(128),";
				$access_sql .= "  [activated] INTEGER,";
				$access_sql .= "  [activations_number] INTEGER,";
				$access_sql .= "  [serial_added] DATETIME";
				$access_sql .= "  ,PRIMARY KEY (serial_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_items_serials_item_id ON " . $table_prefix . "orders_items_serials (item_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_items_serials_order_id ON " . $table_prefix . "orders_items_serials (order_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_items_serials_ord_16 ON " . $table_prefix . "orders_items_serials (order_item_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_items_serials_ser_17 ON " . $table_prefix . "orders_items_serials (serial_number)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_items_serials_user_id ON " . $table_prefix . "orders_items_serials (user_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "orders_serials_activations (";
				$mysql_sql  .= "  `activation_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `serial_id` INT(11) default '0',";
				$mysql_sql  .= "  `order_id` INT(11) default '0',";
				$mysql_sql  .= "  `generation_key` VARCHAR(255),";
				$mysql_sql  .= "  `date_added` DATETIME";
				$mysql_sql  .= "  ,KEY order_id (order_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (activation_id)";
				$mysql_sql  .= "  ,KEY serial_id (serial_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "orders_serials_activations START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "orders_serials_activations (";
				$postgre_sql .= "  activation_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "orders_serials_activations'),";
				$postgre_sql .= "  serial_id INT4 default '0',";
				$postgre_sql .= "  order_id INT4 default '0',";
				$postgre_sql .= "  generation_key VARCHAR(255),";
				$postgre_sql .= "  date_added TIMESTAMP";
				$postgre_sql .= "  ,PRIMARY KEY (activation_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "orders_serials_activations (";
				$access_sql .= "  [activation_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [serial_id] INTEGER,";
				$access_sql .= "  [order_id] INTEGER,";
				$access_sql .= "  [generation_key] VARCHAR(255),";
				$access_sql .= "  [date_added] DATETIME";
				$access_sql .= "  ,PRIMARY KEY (activation_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if ($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_serials_activatio_18 ON " . $table_prefix . "orders_serials_activations (order_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_serials_activatio_19 ON " . $table_prefix . "orders_serials_activations (serial_id)";
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `property_style` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN property_style TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [property_style] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `before_control_html` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN before_control_html TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [before_control_html] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN `after_control_html` TEXT ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN after_control_html TEXT ",
					"access" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN [after_control_html] LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " UPDATE " . $table_prefix . "items_properties SET after_control_html=end_html ";
				$sqls[] = " UPDATE " . $table_prefix . "items_properties SET end_html=NULL ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN `generate_serial` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN generate_serial INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN [generate_serial] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN `activations_number` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN activations_number INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN [activations_number] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "admins ADD COLUMN admin_alias VARCHAR(16) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admin_privileges ADD COLUMN `support_privilege` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "admin_privileges ADD COLUMN support_privilege INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "admin_privileges ADD COLUMN [support_privilege] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "currencies ADD COLUMN currency_value VARCHAR(16) ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN success_message VARCHAR(255) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN `is_placed` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN is_placed INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN [is_placed] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `allow_user_cancel` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN allow_user_cancel INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [allow_user_cancel] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `is_user_cancel` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN is_user_cancel INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [is_user_cancel] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN template_name VARCHAR(255) ";

				if (VA_TYPE == "enterprise") {
					$sql_types = array (
						"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN `is_closed` INT(11) default '0' ",
						"postgre"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_closed INT4 default '0' ",
						"access" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN [is_closed] INTEGER "
					);
					$sqls[] = $sql_types[$db_type];
			  
					$sqls[] = "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN status_icon VARCHAR(128) ";
					$sqls[] = "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN html_start VARCHAR(255) ";
					$sqls[] = "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN html_end VARCHAR(255) ";
			  
				}

			}

			if (comp_vers("2.2.11", $current_db_version) == 1) {
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN language_code VARCHAR(2) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN `tax_free` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN tax_free INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN [tax_free] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN goods_taxable FLOAT(10,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN goods_taxable FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN goods_taxable FLOAT"
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "orders SET goods_taxable=goods_total ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN `tax_free` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN tax_free INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN [tax_free] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `is_default` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN is_default INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [is_default] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
			}

			if (comp_vers("2.2.12", $current_db_version) == 1) {
				$mysql_sql   = "CREATE TABLE " . $table_prefix . "order_custom_properties (";
				$mysql_sql  .= "  `property_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `payment_id` INT(11) default '0',";
				$mysql_sql  .= "  `property_order` INT(11) NOT NULL default '1',";
				$mysql_sql  .= "  `property_name` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `property_description` TEXT,";
				$mysql_sql  .= "  `default_value` TEXT,";
				$mysql_sql  .= "	`property_style` VARCHAR(255),";
				$mysql_sql  .= "  `property_type` INT(11) default '0',";
				$mysql_sql  .= "  `tax_free` INT(11) default '0',";
				$mysql_sql  .= "  `control_type` VARCHAR(16) NOT NULL,";
				$mysql_sql  .= "  `control_style` VARCHAR(255),";
				$mysql_sql  .= "  `control_code` TEXT,";
				$mysql_sql  .= "  `onchange_code` TEXT,";
				$mysql_sql  .= "  `onclick_code` TEXT,";
				$mysql_sql  .= "  `required` INT(11),";
				$mysql_sql  .= "  `before_name_html` TEXT,";
				$mysql_sql  .= "  `after_name_html` TEXT,";
				$mysql_sql  .= "	`before_control_html` TEXT,";
				$mysql_sql  .= "	`after_control_html` TEXT";
				$mysql_sql  .= "  ,PRIMARY KEY (property_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "order_custom_properties START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "order_custom_properties (";
				$postgre_sql .= "  property_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "order_custom_properties'),";
				$postgre_sql .= "  payment_id INT4 default '0',";
				$postgre_sql .= "  property_order INT4 default '0',";
				$postgre_sql .= "  property_name VARCHAR(255),";
				$postgre_sql .= "  property_description TEXT,";
				$postgre_sql .= "  default_value TEXT,";
				$postgre_sql .= "  property_style VARCHAR(255),";
				$postgre_sql .= "  property_type INT4 default '0',";
				$postgre_sql .= "  tax_free INT4 default '0',";
				$postgre_sql .= "  control_type VARCHAR(16),";
				$postgre_sql .= "  control_style VARCHAR(255),";
				$postgre_sql .= "  control_code TEXT,";
				$postgre_sql .= "  onchange_code TEXT,";
				$postgre_sql .= "  onclick_code TEXT,";
				$postgre_sql .= "  required INT4 default '0',";
				$postgre_sql .= "  before_name_html TEXT,";
				$postgre_sql .= "  after_name_html TEXT,";
				$postgre_sql .= "  before_control_html TEXT,";
				$postgre_sql .= "  after_control_html TEXT";
				$postgre_sql .= "  ,PRIMARY KEY (property_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "order_custom_properties (";
				$access_sql .= "  [property_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [payment_id] INTEGER,";
				$access_sql .= "  [property_order] INTEGER,";
				$access_sql .= "  [property_name] VARCHAR(255),";
				$access_sql .= "  [property_description] LONGTEXT,";
				$access_sql .= "  [default_value] LONGTEXT,";
				$access_sql .= "  [property_style] VARCHAR(255),";
				$access_sql .= "  [property_type] INTEGER,";
				$access_sql .= "  [tax_free] INTEGER,";
				$access_sql .= "  [control_type] VARCHAR(16),";
				$access_sql .= "  [control_style] VARCHAR(255),";
				$access_sql .= "  [control_code] LONGTEXT,";
				$access_sql .= "  [onchange_code] LONGTEXT,";
				$access_sql .= "  [onclick_code] LONGTEXT,";
				$access_sql .= "  [required] INTEGER,";
				$access_sql .= "  [before_name_html] LONGTEXT,";
				$access_sql .= "  [after_name_html] LONGTEXT,";
				$access_sql .= "  [before_control_html] LONGTEXT,";
				$access_sql .= "  [after_control_html] LONGTEXT";
				$access_sql .= "  ,PRIMARY KEY (property_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "order_custom_values (";
				$mysql_sql  .= "  `property_value_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `property_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `property_value` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `property_price` FLOAT (10,2),";
				$mysql_sql  .= "  `property_weight` FLOAT (10,4),";
				$mysql_sql  .= "  `hide_value` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `is_default_value` INT(11) default '0'";
				$mysql_sql  .= "  ,KEY hide_value (hide_value)";
				$mysql_sql  .= "  ,PRIMARY KEY (property_value_id)";
				$mysql_sql  .= "  ,KEY property_id (property_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "order_custom_values START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "order_custom_values (";
				$postgre_sql .= "  property_value_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "order_custom_values'),";
				$postgre_sql .= "  property_id INT4 default '0',";
				$postgre_sql .= "  property_value VARCHAR(255),";
				$postgre_sql .= "  property_price FLOAT4 default '0',";
				$postgre_sql .= "  property_weight FLOAT4 default '0',";
				$postgre_sql .= "  hide_value INT4 default '0',";
				$postgre_sql .= "  is_default_value INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (property_value_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "order_custom_values (";
				$access_sql .= "  [property_value_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [property_id] INTEGER,";
				$access_sql .= "  [property_value] VARCHAR(255),";
				$access_sql .= "  [property_price] FLOAT,";
				$access_sql .= "  [property_weight] FLOAT,";
				$access_sql .= "  [hide_value] INTEGER,";
				$access_sql .= "  [is_default_value] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (property_value_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "order_custom_values_pro_13 ON " . $table_prefix . "order_custom_values (property_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "orders_properties (";
				$mysql_sql  .= "  `order_property_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `order_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `property_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `property_order` INT(11) NOT NULL default '1',";
				$mysql_sql  .= "  `property_type` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `property_name` VARCHAR(255) NOT NULL,";
				$mysql_sql  .= "  `property_value` TEXT,";
				$mysql_sql  .= "  `property_price` FLOAT (10,2),";
				$mysql_sql  .= "  `property_weight` FLOAT (10,4),";
				$mysql_sql  .= "  `tax_free` INT(11) default '0'";
				$mysql_sql  .= "  ,PRIMARY KEY (order_property_id)";
				$mysql_sql  .= "  ,KEY order_id (order_id)";
				$mysql_sql  .= "  ,KEY property_id (property_id)";
				$mysql_sql  .= "  ,KEY property_name (property_name))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "orders_properties START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "orders_properties (";
				$postgre_sql .= "  order_property_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "orders_properties'),";
				$postgre_sql .= "  order_id INT4 default '0',";
				$postgre_sql .= "  property_id INT4 default '0',";
				$postgre_sql .= "  property_order INT4 default '1',";
				$postgre_sql .= "  property_type INT4 default '0',";
				$postgre_sql .= "  property_name VARCHAR(255) NOT NULL,";
				$postgre_sql .= "  property_value TEXT,";
				$postgre_sql .= "  property_price FLOAT4 default '0',";
				$postgre_sql .= "  property_weight FLOAT4 default '0',";
				$postgre_sql .= "  tax_free INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (order_property_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "orders_properties (";
				$access_sql .= "  [order_property_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [order_id] INTEGER,";
				$access_sql .= "  [property_id] INTEGER,";
				$access_sql .= "  [property_order] INTEGER,";
				$access_sql .= "  [property_type] INTEGER,";
				$access_sql .= "  [property_name] VARCHAR(255),";
				$access_sql .= "  [property_value] LONGTEXT,";
				$access_sql .= "  [property_price] FLOAT,";
				$access_sql .= "  [property_weight] FLOAT,";
				$access_sql .= "  [tax_free] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (order_property_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_properties_order_id ON " . $table_prefix . "orders_properties (order_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_properties_order__19 ON " . $table_prefix . "orders_properties (order_property_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_properties_property_id ON " . $table_prefix . "orders_properties (property_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "orders_properties_proper_20 ON " . $table_prefix . "orders_properties (property_name)";
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN properties_total FLOAT(10,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN properties_total FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN properties_total FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN properties_taxable FLOAT(10,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN properties_taxable FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN properties_taxable FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " UPDATE " . $table_prefix . "orders SET properties_total=0, properties_taxable=0 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN `disable_out_of_stock` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN disable_out_of_stock INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN [disable_out_of_stock] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN `is_active` INT(11) default '1' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN is_active INT4 default '1' ",
					"access" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN [is_active] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "shipping_types SET is_active=1 ";

			}

			if (comp_vers("2.3", $current_db_version) == 1) {
				
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "newsletters ADD COLUMN orders_recipients TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "newsletters ADD COLUMN orders_recipients TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "newsletters ADD COLUMN orders_recipients LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "orders_serials_activations ADD COLUMN remote_address VARCHAR(32) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_serials_activations ADD COLUMN activation_key TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_serials_activations ADD COLUMN activation_key TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_serials_activations ADD COLUMN activation_key LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

			}


			if (comp_vers("2.4", $current_db_version) == 1) {
				
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_events ADD COLUMN order_items TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_events ADD COLUMN order_items TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_events ADD COLUMN order_items LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_events ADD COLUMN `status_id` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "orders_events ADD COLUMN status_id INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "orders_events ADD COLUMN [status_id] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `is_dispatch` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN is_dispatch INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [is_dispatch] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "credit_cards ADD COLUMN credit_card_code VARCHAR(32) ";
				$sqls[] = "UPDATE " . $table_prefix . "credit_cards SET credit_card_code='MC' WHERE credit_card_name='Mastercard' AND (credit_card_code='' OR credit_card_code IS NULL) ";
				$sqls[] = "UPDATE " . $table_prefix . "credit_cards SET credit_card_code='AMEX' WHERE credit_card_name='American Express' AND (credit_card_code='' OR credit_card_code IS NULL) ";
				$sqls[] = "UPDATE " . $table_prefix . "credit_cards SET credit_card_code='Visa' WHERE credit_card_name='VISA Electron' AND (credit_card_code='' OR credit_card_code IS NULL) ";
				$sqls[] = "UPDATE " . $table_prefix . "credit_cards SET credit_card_code=credit_card_name WHERE credit_card_code='' OR credit_card_code IS NULL ";

				$sqls[] = " UPDATE " . $table_prefix . "global_settings SET setting_type='printable' WHERE setting_type='invoice' ";


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "shipping_modules (";
				$mysql_sql  .= "  `shipping_module_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `shipping_module_name` VARCHAR(255),";
				$mysql_sql  .= "  `module_notes` TEXT,";
				$mysql_sql  .= "  `is_external` INT(11) default '1',";
				$mysql_sql  .= "  `php_external_lib` VARCHAR(255),";
				$mysql_sql  .= "  `external_url` VARCHAR(255),";
				$mysql_sql  .= "  `is_active` INT(11) default '0'";
				$mysql_sql  .= "  ,PRIMARY KEY (shipping_module_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "shipping_modules START 2";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "shipping_modules (";
				$postgre_sql .= "  shipping_module_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "shipping_modules'),";
				$postgre_sql .= "  shipping_module_name VARCHAR(255),";
				$postgre_sql .= "  module_notes TEXT,";
				$postgre_sql .= "  is_external INT4 default '1',";
				$postgre_sql .= "  php_external_lib VARCHAR(255),";
				$postgre_sql .= "  external_url VARCHAR(255),";
				$postgre_sql .= "  is_active INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (shipping_module_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "shipping_modules (";
				$access_sql .= "  [shipping_module_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [shipping_module_name] VARCHAR(255),";
				$access_sql .= "  [module_notes] LONGTEXT,";
				$access_sql .= "  [is_external] INTEGER,";
				$access_sql .= "  [php_external_lib] VARCHAR(255),";
				$access_sql .= "  [external_url] VARCHAR(255),";
				$access_sql .= "  [is_active] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (shipping_module_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "shipping_modules_parameters (";
				$mysql_sql  .= "  `parameter_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `shipping_module_id` INT(11) default '0',";
				$mysql_sql  .= "  `parameter_name` VARCHAR(255),";
				$mysql_sql  .= "  `parameter_source` TEXT,";
				$mysql_sql  .= "  `not_passed` INT(11) default '0'";
				$mysql_sql  .= "  ,PRIMARY KEY (parameter_id)";
				$mysql_sql  .= "  ,KEY shipping_module_id (shipping_module_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "shipping_modules_parameters START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "shipping_modules_parameters (";
				$postgre_sql .= "  parameter_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "shipping_modules_parameters'),";
				$postgre_sql .= "  shipping_module_id INT4 default '0',";
				$postgre_sql .= "  parameter_name VARCHAR(255),";
				$postgre_sql .= "  parameter_source TEXT,";
				$postgre_sql .= "  not_passed INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (parameter_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "shipping_modules_parameters (";
				$access_sql .= "  [parameter_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [shipping_module_id] INTEGER,";
				$access_sql .= "  [parameter_name] VARCHAR(255),";
				$access_sql .= "  [parameter_source] LONGTEXT,";
				$access_sql .= "  [not_passed] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (parameter_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "shipping_modules_paramet_25 ON " . $table_prefix . "shipping_modules_parameters (shipping_module_id)";
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN `shipping_module_id` INT(11) default '0' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN shipping_module_id INT4 default '0' ",
					"access" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN [shipping_module_id] INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql  = " INSERT INTO " . $table_prefix . "shipping_modules (shipping_module_id, shipping_module_name, is_external, is_active) ";
				$sql .= " VALUES (1, 'Custom Shipping', 0, 1) ";
				$sqls[] = $sql;

				$sqls[] = " UPDATE " . $table_prefix . "shipping_types SET shipping_module_id=1 ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN shipping_type_code VARCHAR(64) ";

			}


			if (comp_vers("2.5", $current_db_version) == 1) {
				
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN discount_type INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN discount_type INT4  ",
					"access"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN discount_type INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN discount_amount FLOAT(10,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN discount_amount FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN discount_amount FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN coupons_ids TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN coupons_ids TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN coupons_ids LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN discount_type INT(11)  ",
					"postgre" => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN discount_type INT4  ",
					"access"  => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN discount_type INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN discount_amount FLOAT(10,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN discount_amount FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN discount_amount FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN coupons_ids TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN coupons_ids TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "user_types ADD COLUMN coupons_ids LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN super_image VARCHAR(255) ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "header_links ADD COLUMN menu_path VARCHAR(255) ";
				
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "header_links ADD COLUMN parent_menu_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "header_links ADD COLUMN parent_menu_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "header_links ADD COLUMN parent_menu_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "UPDATE " . $table_prefix . "header_links SET parent_menu_id=menu_id ";
				$sqls[] = "UPDATE " . $table_prefix . "header_links SET menu_path='/' ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN small_image_alt VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN big_image_alt VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN meta_title VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN meta_description VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN meta_keywords VARCHAR(255) ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "categories ADD COLUMN image_alt VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "categories ADD COLUMN image_large VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "categories ADD COLUMN image_large_alt VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "categories ADD COLUMN meta_title VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "categories ADD COLUMN meta_description VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "categories ADD COLUMN meta_keywords VARCHAR(255) ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "articles ADD COLUMN image_small_alt VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "articles ADD COLUMN image_large_alt VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "articles ADD COLUMN meta_title VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "articles ADD COLUMN meta_description VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "articles ADD COLUMN meta_keywords VARCHAR(255) ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN image_small_alt VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN image_large_alt VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN meta_title VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN meta_description VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN meta_keywords VARCHAR(255) ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN cc_first_name VARCHAR(64) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN cc_last_name VARCHAR(64) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "item_types ADD COLUMN is_gift_voucher INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "item_types ADD COLUMN is_gift_voucher INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "item_types ADD COLUMN is_gift_voucher INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

			}


			if (comp_vers("2.5.1", $current_db_version) == 1) {
				$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN reset_password_code VARCHAR(64) ";
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "users ADD COLUMN reset_password_date DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "users ADD COLUMN reset_password_date TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "users ADD COLUMN reset_password_date DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN order_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN order_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN order_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN order_item_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN order_item_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN order_item_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN failure_action INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN failure_action INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN failure_action INTEGER " 
				);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "items_prices (";
				$mysql_sql  .= "  `price_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `item_id` INT(11) default '0',";
				$mysql_sql  .= "  `is_active` INT(11) default '0',";
				$mysql_sql  .= "  `min_quantity` INT(11) default '1',";
				$mysql_sql  .= "  `max_quantity` INT(11) default '1',";
				$mysql_sql  .= "  `price` DOUBLE(16,2) default '0',";
				$mysql_sql  .= "  `discount_action` INT(11) default '0'";
				$mysql_sql  .= "  ,KEY item_id (item_id)";
				$mysql_sql  .= "  ,PRIMARY KEY (price_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "shipping_modules_parameters START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "items_prices (";
				$postgre_sql .= "  price_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "items_prices'),";
				$postgre_sql .= "  item_id INT4 default '0',";
				$postgre_sql .= "  is_active INT4 default '0',";
				$postgre_sql .= "  min_quantity INT4 default '1',";
				$postgre_sql .= "  max_quantity INT4 default '1',";
				$postgre_sql .= "  price FLOAT4 default '0',";
				$postgre_sql .= "  discount_action INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (price_id))";
                        
				$access_sql  = "CREATE TABLE " . $table_prefix . "items_prices (";
				$access_sql .= "  [price_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [item_id] INTEGER,";
				$access_sql .= "  [is_active] INTEGER,";
				$access_sql .= "  [min_quantity] INTEGER,";
				$access_sql .= "  [max_quantity] INTEGER,";
				$access_sql .= "  [price] FLOAT,";
				$access_sql .= "  [discount_action] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (price_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "items_prices_item_id ON " . $table_prefix . "items_prices (item_id)";
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN hide_add_list INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN hide_add_list INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN hide_add_list INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN hide_add_details INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN hide_add_details INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN hide_add_details INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "pages ADD COLUMN meta_title VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "pages ADD COLUMN meta_description VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "pages ADD COLUMN meta_keywords VARCHAR(255) ";
			}

			if (comp_vers("2.5.3", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_times ADD COLUMN availability_time INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "shipping_times ADD COLUMN availability_time INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "shipping_times ADD COLUMN availability_time INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN shipping_order INT(11) default '1' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN shipping_order INT4 default '1' ",
					"access"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN shipping_order INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN shipping_time INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN shipping_time INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN shipping_time INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "UPDATE " . $table_prefix . "shipping_types SET shipping_order=1 ";


				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN processing_time INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN processing_time INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN processing_time INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN shipping_expecting_date DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN shipping_expecting_date TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN shipping_expecting_date DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN shipping_tracking_id VARCHAR(255) ";
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN shipping_expecting_date DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN shipping_expecting_date TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN shipping_expecting_date DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN is_rss INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN is_rss INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN is_rss INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_limit INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_limit INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_limit INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_on_breadcrumb INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_on_breadcrumb INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_on_breadcrumb INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_on_list INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_on_list INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "articles_categories ADD COLUMN rss_on_list INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN admin_id_added_by INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN admin_id_added_by INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN admin_id_added_by INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN admin_id_modified_by INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN admin_id_modified_by INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN admin_id_modified_by INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN date_added DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN date_added TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN date_added DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN date_modified DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN date_modified TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN date_modified DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN admin_id_added_by INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN admin_id_added_by INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN admin_id_added_by INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN admin_id_modified_by INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN admin_id_modified_by INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN admin_id_modified_by INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN date_added DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN date_added TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN date_added DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN date_modified DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN date_modified TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN date_modified DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN priority_rank INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN priority_rank INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN priority_rank INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN is_default INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN is_default INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN is_default INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN admin_html TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN admin_html TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "support_priorities ADD COLUMN admin_html LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "UPDATE " . $table_prefix . "support_priorities SET priority_rank=2 ";
				$sqls[] = "UPDATE " . $table_prefix . "support SET support_priority_id=2 WHERE support_priority_id IS NULL ";
				$sqls[] = "UPDATE " . $table_prefix . "support_priorities SET is_default=0, priority_rank=1, admin_html='<img src=\"../images/high.gif\" width=\"8\" height=\"12\" border=\"0\">' WHERE priority_id=1 ";
				$sqls[] = "UPDATE " . $table_prefix . "support_priorities SET is_default=1, priority_rank=2 WHERE priority_id=2 ";
				$sqls[] = "UPDATE " . $table_prefix . "support_priorities SET is_default=0, priority_rank=3, admin_html='<img src=\"../images/low.gif\" width=\"8\" height=\"12\" border=\"0\">' WHERE priority_id=3 ";
				

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "banners (";
				$mysql_sql  .= "  `banner_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `banner_rank` INT(11) default '1',";
				$mysql_sql  .= "  `banner_title` VARCHAR(255),";
				$mysql_sql  .= "  `show_title` INT(11) default '0',";
				$mysql_sql  .= "  `image_src` VARCHAR(255),";
				$mysql_sql  .= "  `image_alt` VARCHAR(255),";
				$mysql_sql  .= "  `html_text` TEXT,";
				$mysql_sql  .= "  `target_url` VARCHAR(255),";
				$mysql_sql  .= "  `is_new_window` INT(11) default '0',";
				$mysql_sql  .= "  `is_active` INT(11) default '0',";
				$mysql_sql  .= "  `show_on_ssl` INT(11) default '0',";
				$mysql_sql  .= "  `max_impressions` INT(11) default '0',";
				$mysql_sql  .= "  `max_clicks` INT(11) default '0',";
				$mysql_sql  .= "  `expiry_date` DATETIME,";
				$mysql_sql  .= "  `total_impressions` INT(11) default '0',";
				$mysql_sql  .= "  `total_clicks` INT(11) default '0'";
				$mysql_sql  .= "  ,KEY is_active (is_active)";
				$mysql_sql  .= "  ,KEY max_clicks (max_clicks)";
				$mysql_sql  .= "  ,KEY max_impressions (max_impressions)";
				$mysql_sql  .= "  ,PRIMARY KEY (banner_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "banners START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "banners (";
				$postgre_sql .= "  banner_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "banners'),";
				$postgre_sql .= "  banner_rank INT4 default '1',";
				$postgre_sql .= "  banner_title VARCHAR(255),";
				$postgre_sql .= "  show_title INT4 default '0',";
				$postgre_sql .= "  image_src VARCHAR(255),";
				$postgre_sql .= "  image_alt VARCHAR(255),";
				$postgre_sql .= "  html_text TEXT,";
				$postgre_sql .= "  target_url VARCHAR(255),";
				$postgre_sql .= "  is_new_window INT4 default '0',";
				$postgre_sql .= "  is_active INT4 default '0',";
				$postgre_sql .= "  show_on_ssl INT4 default '0',";
				$postgre_sql .= "  max_impressions INT4 default '0',";
				$postgre_sql .= "  max_clicks INT4 default '0',";
				$postgre_sql .= "  expiry_date TIMESTAMP,";
				$postgre_sql .= "  total_impressions INT4 default '0',";
				$postgre_sql .= "  total_clicks INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (banner_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "banners (";
				$access_sql .= "  [banner_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [banner_rank] INTEGER,";
				$access_sql .= "  [banner_title] VARCHAR(255),";
				$access_sql .= "  [show_title] INTEGER,";
				$access_sql .= "  [image_src] VARCHAR(255),";
				$access_sql .= "  [image_alt] VARCHAR(255),";
				$access_sql .= "  [html_text] LONGTEXT,";
				$access_sql .= "  [target_url] VARCHAR(255),";
				$access_sql .= "  [is_new_window] INTEGER,";
				$access_sql .= "  [is_active] INTEGER,";
				$access_sql .= "  [show_on_ssl] INTEGER,";
				$access_sql .= "  [max_impressions] INTEGER,";
				$access_sql .= "  [max_clicks] INTEGER,";
				$access_sql .= "  [expiry_date] DATETIME,";
				$access_sql .= "  [total_impressions] INTEGER,";
				$access_sql .= "  [total_clicks] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (banner_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "banners_is_active ON " . $table_prefix . "banners (is_active)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "banners_max_clicks ON " . $table_prefix . "banners (max_clicks)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "banners_max_impressions ON " . $table_prefix . "banners (max_impressions)";
				}


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "banners_assigned (";
				$mysql_sql  .= "  `banner_id` INT(11) NOT NULL default '0',";
				$mysql_sql  .= "  `group_id` INT(11) NOT NULL default '0'";
				$mysql_sql  .= "  ,PRIMARY KEY (banner_id,group_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "banners_assigned START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "banners_assigned (";
				$postgre_sql .= "  banner_id INT4 NOT NULL default '0',";
				$postgre_sql .= "  group_id INT4 NOT NULL default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (banner_id,group_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "banners_assigned (";
				$access_sql .= "  [banner_id] INTEGER NOT NULL,";
				$access_sql .= "  [group_id] INTEGER NOT NULL";
				$access_sql .= "  ,PRIMARY KEY (banner_id,group_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];


				$mysql_sql   = "CREATE TABLE " . $table_prefix . "banners_groups (";
				$mysql_sql  .= "  `group_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `group_name` VARCHAR(128),";
				$mysql_sql  .= "  `group_desc` TEXT,";
				$mysql_sql  .= "  `is_active` INT(11) default '0'";
				$mysql_sql  .= "  ,KEY is_active (is_active)";
				$mysql_sql  .= "  ,PRIMARY KEY (group_id))";

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "banners_groups_is_active ON " . $table_prefix . "banners_groups (is_active)";
				}

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "banners_groups START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "banners_groups (";
				$postgre_sql .= "  group_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "banners_groups'),";
				$postgre_sql .= "  group_name VARCHAR(128),";
				$postgre_sql .= "  group_desc TEXT,";
				$postgre_sql .= "  is_active INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (group_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "banners_groups (";
				$access_sql .= "  [group_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [group_name] VARCHAR(128),";
				$access_sql .= "  [group_desc] LONGTEXT,";
				$access_sql .= "  [is_active] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (group_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "banners_clicks (";
				$mysql_sql  .= "  `click_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `banner_id` INT(11) default '0',";
				$mysql_sql  .= "  `user_id` INT(11) default '0',";
				$mysql_sql  .= "  `remote_address` VARCHAR(50),";
				$mysql_sql  .= "  `click_date` DATETIME NOT NULL";
				$mysql_sql  .= "  ,KEY banner_id (banner_id)";
				$mysql_sql  .= "  ,KEY click_date (click_date)";
				$mysql_sql  .= "  ,PRIMARY KEY (click_id)";
				$mysql_sql  .= "  ,KEY user_id (user_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "banners_clicks START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "banners_clicks (";
				$postgre_sql .= "  click_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "banners_clicks'),";
				$postgre_sql .= "  banner_id INT4 default '0',";
				$postgre_sql .= "  user_id INT4 default '0',";
				$postgre_sql .= "  remote_address VARCHAR(50),";
				$postgre_sql .= "  click_date TIMESTAMP NOT NULL";
				$postgre_sql .= "  ,PRIMARY KEY (click_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "banners_clicks (";
				$access_sql .= "  [click_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [banner_id] INTEGER,";
				$access_sql .= "  [user_id] INTEGER,";
				$access_sql .= "  [remote_address] VARCHAR(50),";
				$access_sql .= "  [click_date] DATETIME";
				$access_sql .= "  ,PRIMARY KEY (click_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "banners_clicks_banner_id ON " . $table_prefix . "banners_clicks (banner_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "banners_clicks_click_date ON " . $table_prefix . "banners_clicks (click_date)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "banners_clicks_user_id ON " . $table_prefix . "banners_clicks (user_id)";
				}

				$mysql_sql   = "CREATE TABLE " . $table_prefix . "support_users_priorities (";
				$mysql_sql  .= "  `user_priority_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql  .= "  `priority_id` INT(11) default '0',";
				$mysql_sql  .= "  `user_id` INT(11) default '0',";
				$mysql_sql  .= "  `user_email` VARCHAR(255)";
				$mysql_sql  .= "  ,PRIMARY KEY (user_priority_id)";
				$mysql_sql  .= "  ,KEY priority_id (priority_id)";
				$mysql_sql  .= "  ,KEY user_id (user_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "support_users_priorities START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "support_users_priorities (";
				$postgre_sql .= "  user_priority_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "support_users_priorities'),";
				$postgre_sql .= "  priority_id INT4 default '0',";
				$postgre_sql .= "  user_id INT4 default '0',";
				$postgre_sql .= "  user_email VARCHAR(255)";
				$postgre_sql .= "  ,PRIMARY KEY (user_priority_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "support_users_priorities (";
				$access_sql .= "  [user_priority_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [priority_id] INTEGER,";
				$access_sql .= "  [user_id] INTEGER,";
				$access_sql .= "  [user_email] VARCHAR(255)";
				$access_sql .= "  ,PRIMARY KEY (user_priority_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "support_users_priorities_31 ON " . $table_prefix . "support_users_priorities (priority_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "support_users_priorities_32 ON " . $table_prefix . "support_users_priorities (user_id)";
				}

				$sqls[] = "ALTER TABLE " . $table_prefix . "categories ADD COLUMN list_template VARCHAR(128) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "categories ADD COLUMN details_template VARCHAR(128) ";

				// update home page layout
				$layout_id = get_setting_value($settings, "layout_id");
				if (!strlen($layout_id)) {
					$sql = " SELECT MIN(layout_id) FROM " . $table_prefix . "layouts ";
					$db->query($sql);
					if ($db->next_record()) {
						$layout_id = $db->f("layout_id");
					}
				}
				$sql = "SELECT * FROM " . $table_prefix . "page_settings WHERE page_name='index' AND layout_id=" . $db->tosql($layout_id, INTEGER);
				$db->query($sql);
				while ($db->next_record()) {
					$setting_name = $db->f("setting_name");
					$setting_order = $db->f("setting_order");
					$setting_value = $db->f("setting_value");
					$sql  = " INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'index', ";
					$sql .= $db->tosql($setting_name, TEXT, true, false) . ",";
					$sql .= $db->tosql($setting_order, INTEGER) . ",";
					$sql .= $db->tosql($setting_value, TEXT, true, false) . ")";
					$sqls[] = $sql;
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN buying_price DOUBLE(16,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN buying_price FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN buying_price FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN `use_stock_level` INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN use_stock_level INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN [use_stock_level] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "UPDATE " . $table_prefix . "items_properties_values SET hide_out_of_stock=0 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN `pending_status_id` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN pending_status_id INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN [pending_status_id] INTEGER " 
				);
				$sqls[] = $sql_types[$db_type];
			}

			if (comp_vers("2.5.4", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_prices ADD COLUMN user_type_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_prices ADD COLUMN user_type_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items_prices ADD COLUMN user_type_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = "UPDATE " . $table_prefix . "items_prices SET user_type_id=0 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN item_type_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN item_type_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN item_type_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN incoming_type_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN incoming_type_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN incoming_type_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN incoming_product_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN incoming_product_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN incoming_product_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN file_path VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN attachments_dir VARCHAR(255) ";
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN attachments_mask TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN attachments_mask TEXT ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_departments ADD COLUMN attachments_mask LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "languages ADD COLUMN language_order INT(11) default '1' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "languages ADD COLUMN language_order INT4 default '1' ",
					"access"  => "ALTER TABLE " . $table_prefix . "languages ADD COLUMN language_order INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = "UPDATE " . $table_prefix . "languages SET language_order=1 ";

			}

			if (comp_vers("2.5.5", $current_db_version) == 1) {
			  
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support ADD COLUMN admin_id_modified_by INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support ADD COLUMN admin_id_modified_by INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support ADD COLUMN admin_id_modified_by INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support ADD COLUMN date_viewed DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support ADD COLUMN date_viewed TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "support ADD COLUMN date_viewed DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN date_modified DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN date_modified TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN date_modified DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN admin_id_modified_by INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN admin_id_modified_by INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_messages ADD COLUMN admin_id_modified_by INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "custom_blocks ADD COLUMN block_name VARCHAR(255) ";
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "custom_blocks ADD COLUMN block_notes TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "custom_blocks ADD COLUMN block_notes TEXT ",
					"access"  => "ALTER TABLE " . $table_prefix . "custom_blocks ADD COLUMN block_notes LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];
				$sql = " SELECT * FROM " . $table_prefix . "custom_blocks ";
				$db->query($sql);
				while ($db->next_record()) {
					$block_id = $db->f("block_id");
					$block_name = strip_tags(get_translation($db->f("block_title")));
					if (!$block_name) {
						$block_name = trim(strip_tags(get_translation($db->f("block_desc"))));
					}
					$words = explode(" ", $block_name);
					if(sizeof($words) > 5) {
						$block_name = "";
						for ($i = 0; $i < 5; $i++) {
							$block_name .= $words[$i] . " ";
						}
					} 
					$sqls[] = "UPDATE " . $table_prefix . "custom_blocks SET block_name=" . $db->tosql($block_name, TEXT) . " WHERE block_id=" . $db->tosql($block_id, INTEGER);
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN show_sub_products INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN show_sub_products INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN show_sub_products INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_prices ADD COLUMN properties_discount DOUBLE(16,2) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_prices ADD COLUMN properties_discount FLOAT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "items_prices ADD COLUMN properties_discount FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN use_on_second INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN use_on_second INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN use_on_second INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "items_properties SET use_on_second=0 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `is_list` INT(11) default '1' ",
					"postgre"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN is_list INT4 default '1' ",
					"access" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [is_list] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "order_statuses SET is_list=1 ";


				// update menu links for new structure
				$header_links = array();
				$sql = "SELECT * FROM " . $table_prefix . "header_links ";
				$db->query($sql);
				while ($db->next_record()) {
					$menu_id = $db->f("menu_id");
					$parent_menu_id = $db->f("parent_menu_id");
					$header_links[$menu_id] = $parent_menu_id;
				}
				foreach ($header_links as $menu_id => $parent_menu_id) {
					if (!$parent_menu_id || $parent_menu_id == $menu_id) {
						$parent_menu_id = 0;
					}
					$menu_path = ""; $current_parent_id = $parent_menu_id;
					while ($current_parent_id) {
						$menu_path = $current_parent_id.",".$menu_path;
						$sql = "SELECT parent_menu_id FROM " . $table_prefix . "header_links WHERE menu_id=".$db->tosql($current_parent_id, INTEGER);
						$db->query($sql);
						if ($db->next_record()) {
							$parent_id = $db->f("parent_menu_id");
							if ($parent_id == $current_parent_id) {
								$current_parent_id = 0;
							} else {
								$current_parent_id = $parent_id;
							}
						} else {
							$current_parent_id = 0;
						}
					}
					$sql  = " UPDATE " . $table_prefix . "header_links SET ";
					$sql .= " parent_menu_id=" . $db->tosql($parent_menu_id, INTEGER) . ", ";
					$sql .= " menu_path=" . $db->tosql($menu_path, TEXT);
					$sql .= " WHERE menu_id=" . $db->tosql($menu_id, INTEGER);
					$sqls[] = $sql;
				}	

				
				//update for forum
				
				//create table forum_list
			  $mysql_sql = "CREATE TABLE `" . $table_prefix . "forum_list` (";
			  $mysql_sql .= "`forum_id` int(11) NOT NULL auto_increment,";
			  $mysql_sql .= "`category_id` int(11) NOT NULL,";	
			  $mysql_sql .= "`forum_name` varchar(255) NOT NULL,";
			  $mysql_sql .= "`forum_order` int(11) default '0',";
			  $mysql_sql .= "`short_description` text,";
			  $mysql_sql .= "`full_description` text,";
			  $mysql_sql .= "`small_image` varchar(255),";
			  $mysql_sql .= "`large_image` varchar(255),";
			  $mysql_sql .= "`date_added` datetime NOT NULL default '0000-00-00 00:00:00',";
			  $mysql_sql .= "`threads_number` int(11) NOT NULL default '0',";
			  $mysql_sql .= "`messages_number` int(11) NOT NULL default '0',";
			  $mysql_sql .= "`last_post_added` datetime,";
			  $mysql_sql .= "`last_post_user_id` int(11) NOT NULL default '0',";
			  $mysql_sql .= "`last_post_thread_id` int(11) NOT NULL default '0',";
			  $mysql_sql .= "`allowed_view` int(11) default '0',";
			  $mysql_sql .= "PRIMARY KEY (`forum_id`),";
			  $mysql_sql .= "KEY `category_id` (`category_id`,`last_post_user_id`))";
			
				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "forum_list START 1";
				}
			  $postgre_sql = "CREATE TABLE `" . $table_prefix . "forum_list` (";
			  $postgre_sql .= "`forum_id` INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "forum_list'),";
			  $postgre_sql .= "`category_id` INT4 NOT NULL,";
			  $postgre_sql .= "`forum_name` VARCHAR(255) NOT NULL,";
			  $postgre_sql .= "`forum_order` INT4 default '0',";
			  $postgre_sql .= "`short_description` TEXT,";
			  $postgre_sql .= "`full_description` TEXT,";
			  $postgre_sql .= "`small_image` VARCHAR(255),";
			  $postgre_sql .= "`large_image` VARCHAR(255),";
			  $postgre_sql .= "`date_added` TIMESTAMP NOT NULL,";
			  $postgre_sql .= "`threads_number` INT4 NOT NULL default '0',";
			  $postgre_sql .= "`messages_number` INT4 NOT NULL default '0',";
			  $postgre_sql .= "`last_post_added` TIMESTAMP ,";
			  $postgre_sql .= "`last_post_user_id` INT4 NOT NULL default '0',";
			  $postgre_sql .= "`last_post_thread_id` INT4 NOT NULL default '0',";
			  $postgre_sql .= "`allowed_view` INT4 default '0',";
			  $postgre_sql .= "PRIMARY KEY (`forum_id`))";
		
			  $access_sql = "CREATE TABLE " . $table_prefix . "forum_list (";
			  $access_sql .= "[forum_id] COUNTER NOT NULL,";
			  $access_sql .= "[category_id] INTEGER NOT NULL,";
			  $access_sql .= "[forum_name] VARCHAR(255) NOT NULL,";
			  $access_sql .= "[forum_order] INTEGER NOT NULL,";
			  $access_sql .= "[short_description] LONGTEXT,";
			  $access_sql .= "[full_description] LONGTEXT,";
			  $access_sql .= "[small_image] VARCHAR(255),";
			  $access_sql .= "[large_image] VARCHAR(255),";
			  $access_sql .= "[date_added] DATETIME NOT NULL,";
			  $access_sql .= "[threads_number] INTEGER NOT NULL,";
			  $access_sql .= "[messages_number] INTEGER NOT NULL,";
			  $access_sql .= "[last_post_added] DATETIME ,";
			  $access_sql .= "[last_post_user_id] INTEGER NOT NULL,";
			  $access_sql .= "[last_post_thread_id] INTEGER NOT NULL,";
			  $access_sql .= "[allowed_view] INTEGER NOT NULL,";
			  $access_sql .= "PRIMARY KEY (forum_id))";

			  $sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
			  $sqls[] = $sql_types[$db_type];
				
				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "category_id ON " . $table_prefix . "forum_list (category_id, last_post_user_id)";
				}

				//create table forum_categories
			  $mysql_sql = "CREATE TABLE `" . $table_prefix . "forum_categories` (";
			  $mysql_sql .= "`category_id` int(11) NOT NULL auto_increment,";
			  $mysql_sql .= "`category_name` varchar(255) NOT NULL,";
			  $mysql_sql .= "`category_order` int(11) default '0',";
			  $mysql_sql .= "`short_description` text,";
			  $mysql_sql .= "`full_description` text,";
			  $mysql_sql .= "`allowed_view` int(11) default '0',";
			  $mysql_sql .= "PRIMARY KEY (`category_id`))";
			
				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "forum_categories START 1";
				}
			  $postgre_sql = "CREATE TABLE `" . $table_prefix . "forum_categories` (";
			  $postgre_sql .= "`category_id` INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "forum_categories'),";
			  $postgre_sql .= "`category_name` VARCHAR(255) NOT NULL,";
			  $postgre_sql .= "`category_order` INT4 default '0',";
			  $postgre_sql .= "`short_description` TEXT,";
			  $postgre_sql .= "`full_description` TEXT,";
			  $postgre_sql .= "`allowed_view` INT4 default '0',";
			  $postgre_sql .= "PRIMARY KEY (`category_id`))";
			
			  $access_sql  = "CREATE TABLE `" . $table_prefix . "forum_categories` (";
			  $access_sql .= "[category_id] COUNTER  NOT NULL,";
			  $access_sql .= "[category_name] VARCHAR(255) NOT NULL,";
			  $access_sql .= "[category_order] INTEGER NOT NULL,";
			  $access_sql .= "[short_description] LONGTEXT,";
			  $access_sql .= "[full_description] LONGTEXT,";
			  $access_sql .= "[allowed_view] INTEGER NOT NULL,";
			  $access_sql .= "PRIMARY KEY (category_id))";

			  $sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
			  $sqls[] = $sql_types[$db_type];

				//create table forum_moderators
			  $mysql_sql  = "CREATE TABLE " . $table_prefix . "forum_moderators (";
			  $mysql_sql .= " `admin_id` INT(11) NOT NULL default '0',";
			  $mysql_sql .= " `forum_id` INT(11) NOT NULL default '0',";
			  $mysql_sql .= " `is_default_forum` INT(11) default '0'";
			  $mysql_sql .= " ,PRIMARY KEY (admin_id,forum_id))";

			  $postgre_sql  = "CREATE TABLE " . $table_prefix . "forum_moderators (";
			  $postgre_sql .= "  admin_id INT4 NOT NULL default '0',";
			  $postgre_sql .= "  forum_id INT4 NOT NULL default '0',";
			  $postgre_sql .= "  is_default_forum INT4 default '0'";
			  $postgre_sql .= "  ,PRIMARY KEY (admin_id,forum_id))";
			
			  $access_sql  = "CREATE TABLE " . $table_prefix . "forum_moderators (";
			  $access_sql .= "  [admin_id] INTEGER NOT NULL,";
			  $access_sql .= "  [forum_id] INTEGER NOT NULL,";
			  $access_sql .= "  [is_default_forum] INTEGER";
			  $access_sql .= "  ,PRIMARY KEY (admin_id,forum_id))";

			  $sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
			  $sqls[] = $sql_types[$db_type];

				//add field forum_id
			  $sql_types = array (
			  	"mysql"   => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN forum_id INT(11) NOT NULL",
			  	"postgre" => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN forum_id INT4 NOT NULL",
			  	"access"  => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN forum_id INTEGER "
			  );
			  $sqls[] = $sql_types[$db_type];
			        
				//add field user_id
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "forum_messages ADD COLUMN user_id INT(11) NULL ",
					"postgre" => "ALTER TABLE " . $table_prefix . "forum_messages ADD COLUMN user_id INT4 NULL",
					"access"  => "ALTER TABLE " . $table_prefix . "forum_messages ADD COLUMN user_id INTEGER "
				);  
			  $sqls[] = $sql_types[$db_type];

				//make content for forum
				$sqls[] = "INSERT INTO " . $table_prefix . "forum_categories (category_name, category_order, short_description, full_description, allowed_view) VALUES ('General', 1, 'General category', 'General category', 1)";

				$date_added = va_time();
				$sql = "SELECT count(*) FROM " . $table_prefix . "forum";
				$threads_number = get_db_value($sql);
				$sql = "SELECT count(*) FROM " . $table_prefix . "forum_messages";
				$messages_number = get_db_value($sql);
				$sql = " SELECT thread_id, date_added, user_id FROM " . $table_prefix . "forum ORDER BY date_added DESC ";
				$db->RecordsPerPage = 1;
				$db->PageNumber = 1;
				if ($db->query($sql)) {
					if ($db->next_record()) {
						$last_post_added = $db->f("date_added");
						$last_post_user_id = $db->f("user_id");
						$last_post_thread_id = $db->f("thread_id");
					} else {
						$last_post_added = va_date();
						$last_post_user_id = 0;
						$last_post_thread_id = 0;
					}
				}
					
				$sql  = " INSERT INTO " . $table_prefix . "forum_list (category_id, forum_name, forum_order, date_added, threads_number, messages_number, last_post_added, last_post_user_id, last_post_thread_id, allowed_view) VALUES ";
				$sql .= " (1, 'Forum', 1, " . $db->tosql($date_added, DATETIME)  . ", " . $threads_number . ", " . $messages_number . ", " . $db->tosql($last_post_added, DATETIME) . ", " . $last_post_user_id . ", " . $last_post_thread_id . ", 1)";
				$sqls[] = $sql;

				$sqls[] = "UPDATE " . $table_prefix . "forum SET forum_id = 1";


				// create forum_topic list layout
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topic', 'left_column_hide', NULL, '1')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topic', 'left_column_width', NULL, '')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topic', 'middle_column_hide', NULL, '0')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topic', 'middle_column_width', NULL, '100%')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topic', 'right_column_hide', NULL, '1')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topic', 'right_column_width', NULL, '')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topic', 'forum_view_topic', 0, 'middle')";

				// create forum_list list layout
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_list', 'left_column_hide', NULL, '1')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_list', 'left_column_width', NULL, '')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_list', 'middle_column_hide', NULL, '0')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_list', 'middle_column_width', NULL, '100%')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_list', 'right_column_hide', NULL, '1')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_list', 'right_column_width', NULL, '')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_list', 'forum_list', 0, 'middle')";

				// create forum_topics list layout
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topics', 'left_column_hide', NULL, '1')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topics', 'left_column_width', NULL, '')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topics', 'middle_column_hide', NULL, '0')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topics', 'middle_column_width', NULL, '100%')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topics', 'right_column_hide', NULL, '1')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topics', 'right_column_width', NULL, '')";
				$sqls[] = "INSERT INTO " . $table_prefix . "page_settings (layout_id, page_name, setting_name, setting_order, setting_value) VALUES (0, 'forum_topics', 'forum_topics_block', 0, 'middle')";

				$sqls[] = " UPDATE " . $table_prefix . "header_links SET menu_url='forums.php' WHERE menu_url='forum.php'";
				//end update for forum

				//begin changes related to Knowledge Base settings
        $sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_add_knowledge INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_add_knowledge INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_statuses ADD COLUMN is_add_knowledge INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
        $sqls[] = "INSERT INTO " . $table_prefix . "support_statuses (status_name, status_caption, is_internal, is_add_knowledge) VALUES ('Added to Knowledge Base', 'Add to KB', 1, 1)";
        $sql  = " INSERT INTO " . $table_prefix . "articles_categories (category_path, category_name, category_order, allowed_view, allowed_rate, article_list_fields, article_details_fields, article_required_fields) VALUES ";
        $sql .= " ('0,', 'Knowledge Base', 1, 1, 1, 'article_date,article_title,short_description', 'article_date,article_title,full_description', 'article_date,article_title,full_description')";
        $sqls[] = $sql;

		    $sql = "SELECT max(category_id) FROM " . $table_prefix . "articles_categories";
			  $category_id = get_db_value($sql) + 1;
  			$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('support', 'knowledge_category', '$category_id')";
  			
		    $sql = "SELECT min(status_id) FROM " . $table_prefix . "articles_statuses";
			  $article_status_id = get_db_value($sql);
  			$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('support', 'knowledge_article_status', '$article_status_id')";
				//end changes related to Knowledge Base settings
			} 
			

			if (comp_vers("2.6", $current_db_version) == 1) {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN is_price_edit INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN is_price_edit INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN is_price_edit INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN issue_date DATETIME ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN issue_date TIMESTAMP ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN issue_date DATETIME "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN properties_price DOUBLE(16,2) default '0'",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN properties_price FLOAT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN properties_price FLOAT"
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "items SET properties_price=0 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN processing_fee DOUBLE(16,2) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN processing_fee FLOAT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN processing_fee FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN fee_type INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN fee_type INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "payment_systems ADD COLUMN fee_type INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN processing_fee DOUBLE(16,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN processing_fee FLOAT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN processing_fee FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " ALTER TABLE ". $table_prefix . "black_ips DROP COLUMN adress_action ";
				$sqls[] = " ALTER TABLE ". $table_prefix . "black_ips DROP COLUMN adress_notes ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "black_ips ADD COLUMN address_action INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "black_ips ADD COLUMN address_action INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "black_ips ADD COLUMN address_action INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "black_ips ADD COLUMN address_notes TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "black_ips ADD COLUMN address_notes TEXT ",
					"access"  => "ALTER TABLE " . $table_prefix . "black_ips ADD COLUMN address_notes LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "black_ips SET address_action=1 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN property_type_id INT(11) default '1' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN property_type_id INT4 default '1' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN property_type_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "items_properties SET property_type_id=1 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN sub_item_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN sub_item_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN sub_item_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN additional_price DOUBLE(16,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN additional_price FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties ADD COLUMN additional_price FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN sub_item_id INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN sub_item_id INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN sub_item_id INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$mysql_sql  = "CREATE TABLE ".$table_prefix."banned_contents (";
				$mysql_sql .= "  `content_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql .= "  `content_text` VARCHAR(255) NOT NULL";
				$mysql_sql .= "  ,PRIMARY KEY (content_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "banned_contents START 1";
				}
				$postgre_sql  = "CREATE TABLE ".$table_prefix."banned_contents (";
				$postgre_sql .= "  content_id INT4 NOT NULL DEFAULT nextval('seq_".$table_prefix."banned_contents'),";
				$postgre_sql .= "  content_text VARCHAR(255) NOT NULL";
				$postgre_sql .= "  ,PRIMARY KEY (content_id))";

				$access_sql  = "CREATE TABLE ".$table_prefix."banned_contents (";
				$access_sql .= "  [content_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [content_text] VARCHAR(255)";
				$access_sql .= "  ,PRIMARY KEY (content_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "item_types ADD COLUMN is_bundle INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "item_types ADD COLUMN is_bundle INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "item_types ADD COLUMN is_bundle INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
				$sqls[] = " UPDATE " . $table_prefix . "item_types SET is_bundle=0 ";
				$sqls[] = " INSERT INTO " . $table_prefix . "item_types (item_type_name, is_gift_voucher, is_bundle) VALUES ('Bundle', 0, 1) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN parent_item_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN parent_item_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN parent_item_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_notify INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_notify INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_notify INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_recipient VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_recipient VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_recipient VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_originator VARCHAR(64) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_originator VARCHAR(64) ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_originator VARCHAR(64) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_message TEXT",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_message TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN sms_message LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " UPDATE " . $table_prefix . "page_settings SET setting_name='prod_offers_recs' WHERE page_name='index' AND setting_name='products_per_page'";
				$sqls[] = " UPDATE " . $table_prefix . "page_settings SET setting_name='prod_offers_cols' WHERE page_name='index' AND setting_name='products_columns'";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN edited_item_fields TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN edited_item_fields TEXT ",
					"access"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN edited_item_fields LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_modules ADD COLUMN tracking_url VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "shipping_modules ADD COLUMN tracking_url VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "shipping_modules ADD COLUMN tracking_url VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "custom_blocks ADD COLUMN block_path VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "custom_blocks ADD COLUMN block_path VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "custom_blocks ADD COLUMN block_path VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_url VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_url VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_url VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_width INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_width INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_width INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_height INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_height INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN preview_height INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items_properties ADD COLUMN property_values_ids TEXT ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_items_properties ADD COLUMN property_values_ids TEXT ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_items_properties ADD COLUMN property_values_ids LONGTEXT "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "currencies ADD COLUMN currency_image VARCHAR(255) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "currencies ADD COLUMN currency_image VARCHAR(255) ",
					"access"  => "ALTER TABLE " . $table_prefix . "currencies ADD COLUMN currency_image VARCHAR(255) "
				);
				$sqls[] = $sql_types[$db_type];
			}
			
			if (comp_vers("2.7", $current_db_version) == 1)
      {
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN is_generate_small_image INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN is_generate_small_image INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN is_generate_small_image INTEGER "
				);
				$sqls[] = $sql_types[$db_type];
				
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN is_generate_big_image INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN is_generate_big_image INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "admins ADD COLUMN is_generate_big_image INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='products' ";
				
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'resize_small_image', '0')";
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'resize_big_image', '0')";
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'resize_super_image', '0')";
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'small_image_max_width', '100')";
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'small_image_max_height', '100')";
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'big_image_max_width', '300')";
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'big_image_max_height', '300')";
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'super_image_max_width', '800')";
				$sqls[] = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ('products', 'super_image_max_height', '600')";

				$sqls[] = "ALTER TABLE " . $table_prefix . "countries ADD COLUMN country_iso_number VARCHAR(4) ";

				$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='global' ";
				$sc_sql = " AND setting_name IN ('product_quantity', 'quantity_control', 'confirm_add', 'redirect_to_cart', 'coupons_enable', 'user_registration', 'display_products', 'default_tax', 'default_tax_note', 'logout_cart_clear', 'reviews_availability') ";
				$db->query($sql . $sc_sql);
				while ($db->next_record()) {
					$setting_name = $db->f("setting_name");
					$setting_value = $db->f("setting_value");
					if ($setting_name == "default_tax_note") {
						$setting_name = "tax_note";
					} else if ($setting_name == "default_tax") {
						$setting_name = "tax_prices";
						if ($setting_value) {
							$setting_value = 1;
						}
					}

					$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type,setting_name,setting_value) VALUES (";
					$sql .= $db->tosql("products", TEXT) . ",";
					$sql .= $db->tosql($setting_name, TEXT) . ", ";
					$sql .= $db->tosql($setting_value, TEXT) . ") ";
					$sqls[] = $sql;
				}

				$sqls[] = " DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='global' " . $sc_sql;

				$mysql_sql  = "CREATE TABLE " . $table_prefix . "tax_rates_items (";
				$mysql_sql .= "  `tax_item_id` INT(11) NOT NULL auto_increment,";
				$mysql_sql .= "  `tax_id` INT(11) default '0',";
				$mysql_sql .= "  `item_type_id` INT(11) default '0',";
				$mysql_sql .= "  `tax_percent` DOUBLE(16,3)";
				$mysql_sql .= "  ,KEY item_type_id (item_type_id)";
				$mysql_sql .= "  ,PRIMARY KEY (tax_item_id)";
				$mysql_sql .= "  ,KEY tax_id (tax_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "tax_rates_items START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "tax_rates_items (";
				$postgre_sql .= "  tax_item_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "tax_rates_items'),";
				$postgre_sql .= "  tax_id INT4 default '0',";
				$postgre_sql .= "  item_type_id INT4 default '0',";
				$postgre_sql .= "  tax_percent FLOAT4";
				$postgre_sql .= "  ,PRIMARY KEY (tax_item_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "tax_rates_items (";
				$access_sql .= "  [tax_item_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [tax_id] INTEGER,";
				$access_sql .= "  [item_type_id] INTEGER,";
				$access_sql .= "  [tax_percent] FLOAT";
				$access_sql .= "  ,PRIMARY KEY (tax_item_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "tax_rates_items_item_type_id ON " . $table_prefix . "tax_rates_items (item_type_id)";
					$sqls[] = "CREATE INDEX " . $table_prefix . "tax_rates_items_tax_id ON " . $table_prefix . "tax_rates_items (tax_id)";
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN tax_percent DOUBLE(16,3) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN tax_percent FLOAT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN tax_percent FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN total_discount_tax DOUBLE(16,2) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN total_discount_tax FLOAT4 default '0'",
					"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN total_discount_tax FLOAT"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN initial_ip VARCHAR(32) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN cookie_ip VARCHAR(32) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN discount_tax_free INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN discount_tax_free INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "coupons ADD COLUMN discount_tax_free INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN registration_ip VARCHAR(32) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN modified_ip VARCHAR(32) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN last_visit_ip VARCHAR(32) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN `item_notify` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN item_notify INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN [item_notify] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN `mail_notify` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_notify INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN [mail_notify] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_to VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_from VARCHAR(64) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_cc VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_bcc VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_reply_to VARCHAR(64) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_return_path VARCHAR(64) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN `mail_type` INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_type INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN [mail_type] INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_subject VARCHAR(255) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_body TEXT",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_body TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN mail_body LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN sms_notify INT(11) ",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN sms_notify INT4 ",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN sms_notify INTEGER"
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN sms_recipient VARCHAR(255) ";
				$sqls[] = "ALTER TABLE " . $table_prefix . "items ADD COLUMN sms_originator VARCHAR(64) ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN sms_message TEXT",
					"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN sms_message TEXT",
					"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN sms_message LONGTEXT"
				);
				$sqls[] = $sql_types[$db_type];


				$mysql_sql  = "CREATE TABLE " . $table_prefix . "items_serials (";
				$mysql_sql .= "  `serial_id` INT(11) NOT NULL AUTO_INCREMENT,";
				$mysql_sql .= "  `item_id` INT(11) default '0',";
				$mysql_sql .= "  `serial_number` VARCHAR(128),";
				$mysql_sql .= "  `used` INT(11) default '0'";
				$mysql_sql .= "  ,KEY item_id (item_id)";
				$mysql_sql .= "  ,PRIMARY KEY (serial_id))";

				if($db_type == "postgre") {
					$sqls[] = "CREATE SEQUENCE seq_" . $table_prefix . "items_serials START 1";
				}
				$postgre_sql  = "CREATE TABLE " . $table_prefix . "items_serials (";
				$postgre_sql .= "  serial_id INT4 NOT NULL DEFAULT nextval('seq_" . $table_prefix . "items_serials'),";
				$postgre_sql .= "  item_id INT4 default '0',";
				$postgre_sql .= "  serial_number VARCHAR(128),";
				$postgre_sql .= "  used INT4 default '0'";
				$postgre_sql .= "  ,PRIMARY KEY (serial_id))";

				$access_sql  = "CREATE TABLE " . $table_prefix . "items_serials (";
				$access_sql .= "  [serial_id]  COUNTER  NOT NULL,";
				$access_sql .= "  [item_id] INTEGER,";
				$access_sql .= "  [serial_number] VARCHAR(128),";
				$access_sql .= "  [used] INTEGER";
				$access_sql .= "  ,PRIMARY KEY (serial_id))";

				$sql_types = array ("mysql" => $mysql_sql, "postgre" => $postgre_sql, "access" => $access_sql);
				$sqls[] = $sql_types[$db_type];

				if ($db_type == "postgre" || $db_type == "access") {
					$sqls[] = "CREATE INDEX " . $table_prefix . "items_serials_item_id ON " . $table_prefix . "items_serials (item_id)";
				}

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_view_topics INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_view_topics INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_view_topics INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_view_topic INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_view_topic INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_view_topic INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_post_topics INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_post_topics INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_post_topics INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_post_replies INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_post_replies INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "forum_list ADD COLUMN allowed_post_replies INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " UPDATE " . $table_prefix . "forum_list SET allowed_view_topics=1 ";
				$sqls[] = " UPDATE " . $table_prefix . "forum_list SET allowed_view_topic=1 ";
				$sqls[] = " UPDATE " . $table_prefix . "forum_list SET allowed_post_topics=1 ";
				$sqls[] = " UPDATE " . $table_prefix . "forum_list SET allowed_post_replies=1 ";

				$sqls[] = "ALTER TABLE " . $table_prefix . "admins ADD COLUMN personal_image VARCHAR(255) ";

				// update categories settings
				$sql  = " SELECT * FROM " . $table_prefix . "page_settings ";
				$sql .= " WHERE (setting_name='categories_type' OR setting_name='ads_categories_type' OR setting_name LIKE 'a_cats_type_%') ";
				$sql .= " AND (setting_value='1' OR setting_value='2') ";
				$db->query($sql);
				while ($db->next_record()) {
					$page_name = $db->f("page_name");
					$setting_name = $db->f("setting_name");
					if ($setting_name == "categories_type") {
						$sql  = " UPDATE " . $table_prefix . "page_settings SET setting_name='subcategories_type' ";
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name='categories_type'";
						$sqls[] = $sql;
						$sql  = " UPDATE " . $table_prefix . "page_settings SET setting_name='subcategories_columns' ";
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name='categories_columns'";
						$sqls[] = $sql;
						$sql  = " UPDATE " . $table_prefix . "page_settings SET setting_name='subcategories_subs' ";
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name='categories_subs'";
						$sqls[] = $sql;
					} else if ($setting_name == "ads_categories_type") {
						$sql  = " UPDATE " . $table_prefix . "page_settings SET setting_name='ads_subcategories_type' ";
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name='ads_categories_type'";
						$sqls[] = $sql;
						$sql  = " UPDATE " . $table_prefix . "page_settings SET setting_name='ads_subcategories_columns' ";
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name='ads_categories_columns'";
						$sqls[] = $sql;
						$sql  = " UPDATE " . $table_prefix . "page_settings SET setting_name='ads_subcategories_subs' ";
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name='ads_categories_subs'";
						$sqls[] = $sql;
					} else if (preg_match("/^a_cats_type_(\d+)$/", $setting_name, $matches)) {
						$top_id = $matches[1];
						$sql  = " UPDATE " . $table_prefix . "page_settings ";
						$sql .= " SET setting_name=" . $db->tosql("a_subcats_type_" . $top_id, TEXT);
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name=" . $db->tosql("a_cats_type_" . $top_id, TEXT);
						$sqls[] = $sql;
						$sql  = " UPDATE " . $table_prefix . "page_settings ";
						$sql .= " SET setting_name=" . $db->tosql("a_subcats_cols_" . $top_id, TEXT);
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name=" . $db->tosql("a_cats_cols_" . $top_id, TEXT);
						$sqls[] = $sql;
						$sql  = " UPDATE " . $table_prefix . "page_settings ";
						$sql .= " SET setting_name=" . $db->tosql("a_subcats_subs_" . $top_id, TEXT);
						$sql .= " WHERE page_name=" . $db->tosql($page_name, TEXT);
						$sql .= " AND setting_name=" . $db->tosql("a_cats_subs_" . $top_id, TEXT);
						$sqls[] = $sql;
					}
				}

			}

			if (comp_vers("2.7.1", $current_db_version) == 1)
			{
				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN message_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN message_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN message_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN admin_id INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN admin_id INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN admin_id INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN attachment_status INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN attachment_status INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "support_attachments ADD COLUMN attachment_status INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sqls[] = " UPDATE " . $table_prefix . "support_attachments SET attachment_status=1, message_id=0, admin_id=0 ";

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN admin_id_added_by INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN admin_id_added_by INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN admin_id_added_by INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				$sql_types = array (
					"mysql"   => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN admin_id_modified_by INT(11) default '0' ",
					"postgre" => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN admin_id_modified_by INT4 default '0' ",
					"access"  => "ALTER TABLE " . $table_prefix . "forum ADD COLUMN admin_id_modified_by INTEGER "
				);
				$sqls[] = $sql_types[$db_type];

				if($db_type == "mysql") {
					$sqls[] = "ALTER TABLE " . $table_prefix . "orders MODIFY COLUMN state_code VARCHAR(8) ";
					$sqls[] = "ALTER TABLE " . $table_prefix . "orders MODIFY COLUMN delivery_state_code VARCHAR(8) ";
					$sqls[] = "ALTER TABLE " . $table_prefix . "users MODIFY COLUMN state_code VARCHAR(8) ";
					$sqls[] = "ALTER TABLE " . $table_prefix . "users MODIFY COLUMN delivery_state_code VARCHAR(8) ";
				} elseif($db_type == "access") {
					$sqls[] = "ALTER TABLE " . $table_prefix . "orders ALTER COLUMN state_code VARCHAR(8) ";
					$sqls[] = "ALTER TABLE " . $table_prefix . "orders ALTER COLUMN delivery_state_code VARCHAR(8) ";
					$sqls[] = "ALTER TABLE " . $table_prefix . "users ALTER COLUMN state_code VARCHAR(8) ";
					$sqls[] = "ALTER TABLE " . $table_prefix . "users ALTER COLUMN delivery_state_code VARCHAR(8) ";
				}

			}
			
			

			$errors = "";
			$db->HaltOnError = "no";
			$queries_success = 0;
			$queries_failed  = 0;
			for($i = 0; $i < sizeof($sqls); $i++) {
	 	   	$sql = $sqls[$i];
				$db->query($sql);
				if($db->Error) {
					$queries_failed++;
					$errors .= $db->Error . "<br>";
				} else {
					$queries_success++;
				}
			}
			
			// set version information in database
			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='version' AND (setting_name='number' OR setting_name='upgraded') ";
			$db->query($sql);
			if ($db->Error) { $errors .= $db->Error . "<br>"; }
			$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ";
			$sql .= " ('version', 'number', " . $db->tosql(VA_RELEASE, TEXT) . ")";
			$db->query($sql);
			if ($db->Error) { $errors .= $db->Error . "<br>"; }
			$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ";
			$sql .= " ('version', 'upgraded', " . $db->tosql(time(), TEXT) . ")";
			$db->query($sql);
			if ($db->Error) { $errors .= $db->Error . "<br>"; }

			set_session("session_errors", $errors);
			set_session("session_queries_failed", $queries_failed);
			set_session("session_queries_success", $queries_success);
		} else {
			$errors = get_session("session_errors");
			$queries_failed = get_session("session_queries_failed");
			$queries_success = get_session("session_queries_success");
		}

		if ($errors) {
			$t->set_var("errors_list", $errors);
			$t->parse("upgrade_result_errors", false);
		} else {
			$t->set_var("upgrade_result_errors", "");
		}

		if ($queries_failed) {
			$t->set_var("total_queries_failed", $queries_failed);
			$t->parse("queries_failed", false);
		} else {
			$t->set_var("queries_failed", "");
		}

		if ($queries_success) {
			$t->set_var("total_queries_success", $queries_success);
			$t->parse("queries_success", false);
		} else {
			$t->set_var("queries_success", "");
		}

		$t->set_var("total_queries", $queries_failed + $queries_success);
		$t->set_var("latest_version", VA_RELEASE);		
		$t->parse("upgrade_result", false);
		
	} elseif (comp_vers(VA_RELEASE, $current_db_version) == 1) {
		$r = new VA_Record("", "upgrade_available");
		$r->add_hidden("operation", TEXT);
		$r->set_form_parameters();
		$t->set_var("ct", time());
		$t->set_var("current_version", $current_db_version);
		$t->set_var("latest_version", VA_RELEASE);
		$t->parse("upgrade_available", false);

		if (comp_vers($last_version, VA_RELEASE) == 1) {
  			$t->set_var("last_version", $last_version);  		
			$t->parse("download_new", false);
		}

	} elseif (comp_vers($last_version, VA_RELEASE) == 1) {
  		$t->set_var("last_version", $last_version);  		
		$t->parse("download_new", false);
		
	} else {
		$t->set_var("current_version", $current_db_version);
		$t->set_var("latest_version", $last_version);		
		$t->parse("no_upgrades", false);
	}
	
	if (!$xml_opened) $t->set_var("NO_XML_CONNECTION", NO_XML_CONNECTION);
	else $t->set_var("NO_XML_CONNECTION", "");
	
	$t->pparse("main", false);
?>
